

#import <Cocoa/Cocoa.h>


// extensions
#import <OBJBRuntime/DBBackgroundView.h>
#import <OBJBRuntime/DBPrefsWindowController.h>




// (C)opyright 2009-2012 KBasic Software - All rights reserved.



#define OBException @"OBException"
#define OBCastException @"OBCastException"



@interface OBBackgroundView : DBBackgroundView
{
    
}
@end

@interface OBPreferences : DBPrefsWindowController
{
}
- (void) PreferencesChanged: (NSMutableString *) Key;
- (NSMutableDictionary *) PreferencesDefaults;
- (NSMutableArray *) PreferencesItemIdentifiers;
- (NSMutableArray *) PreferencesItems; 
@end





/*
 @interface PBXProjectWatcherServerConnection  : NSObject
 -(id)init;
 
 - (bycopy id)openProjectsContainingFile:(bycopy id)fp8;
 - (bycopy id)pathOfProject:(bycopy id)fp8;
 - (bycopy id)nameOfProject:(bycopy id)fp8;
 - (bycopy id)targetsInProject:(bycopy id)fp8;
 - (bycopy id)nameOfTarget:(bycopy id)fp8 inProject:(bycopy id)fp12;
 - (bycopy id)filesOfTypes:(bycopy id)fp8 inTarget:(bycopy id)fp12 ofProject:(bycopy id)fp16;
 - (bycopy id)targetsInProject:(bycopy id)fp8 containingFile:(bycopy id)fp12;
 
 
 
 - (bycopy id)openProjects;
 - (void)addOpenProjectObserver:(byref id)fp8;
 - (void)removeOpenProjectObserver:(byref id)fp8;
 - (bycopy id)filesOfTypes:(bycopy id)fp8 inProject:(bycopy id)fp12;
 - (void)addProjectFileObserver:(byref id)fp8 forDictionary:(bycopy id)fp12;
 - (void)removeProjectFileObserver:(byref id)fp8;
 - (bycopy id)openProjectsAppropriateForFile:(bycopy id)fp8;
 - (bycopy id)activeTargetInProject:(bycopy id)fp8;
 - (void)addTargetObserver:(byref id)fp8 forProjects:(bycopy id)fp12;
 - (void)removeTargetObserver:(byref id)fp8;
 - (void)addTargetFileObserver:(byref id)fp8 forDictionary:(bycopy id)fp12;
 - (void)removeTargetFileObserver:(byref id)fp8;
 - (void)addFileObserver:(byref id)fp8 forFiles:(bycopy id)fp12;
 - (void)removeFileObserver:(byref id)fp8;
 - (bycopy id)pathForFileWithName:(bycopy id)fp8 inProject:(bycopy id)fp12;
 - (void)addFiles:(bycopy id)fp8 toProject:(bycopy id)fp12 nearFile:(bycopy id)fp16 preferredInsertionGroupName:(bycopy id)fp20 addToTargets:(bycopy id)fp24 copyIntoGroupFolder:(BOOL)fp28 createGroupsRecursively:(BOOL)fp32;
 - (void)addFiles:(bycopy id)fp8 toProject:(bycopy id)fp12 nearFile:(bycopy id)fp16 preferredInsertionGroupName:(bycopy id)fp20 addToTargets:(bycopy id)fp24 copyIntoGroupFolder:(BOOL)fp28 createGroupsRecursively:(BOOL)fp32 fileEncoding:(unsigned int)fp36;
 - (void)addGroupWithName:(bycopy id)fp8 path:(bycopy id)fp12 toProject:(bycopy id)fp16 nearFile:(bycopy id)fp20 preferredInsertionGroupName:(bycopy id)fp24;
 - (bycopy id)productSettingsForTarget:(bycopy id)fp8 ofProject:(bycopy id)fp12;
 - (void)setProductSetting:(bycopy id)fp8 forKey:(bycopy id)fp12 inTarget:(bycopy id)fp16 ofProject:(bycopy id)fp20;
 - (void)removeProductSettingForKey:(bycopy id)fp8 inTarget:(bycopy id)fp12 ofProject:(bycopy id)fp16;
 
 
 @end
 
 @interface xcodefake : NSObject
 @end*/

@interface NSString(String_Sorting)
- (NSComparisonResult)caseSensitiveCompare:(NSString *)aString;
@end

@interface NSToolbar(NSSheet_Extensions)
- (void)Show;
@end

@interface runningcompletion : NSObject
{
@public
    
    BOOL bAs;
    BOOL bClass;
    BOOL bBuiltin;
    NSRange triggerRange;
    NSArray *completionList;
    NSTextView *textview;
}
@end

@interface FloatingKeyWindow : NSWindow
@end

@interface AutoCompleteList : NSTableView

{
    BOOL bAs;
    BOOL bDot;
    BOOL bBracket;
    NSMutableString *myCurrentTypeAhead;
    
}
-(void)setAs:(BOOL)b;
-(void)setDot:(BOOL)b;
-(void)setBracket:(BOOL)b;
-(void)setmyCurrentTypeAhead:(NSMutableString*)b;
@end

@interface NSArray(Array_Autocompletion)
- (NSArray *) sortedUniqueArray;
@end

@interface Autocompletion : NSWindowController {
    NSMutableArray *myOriginCompletions;
    NSMutableArray *myCompletions;
    
    NSMutableString *myCurrentTypeAhead;
    NSString *sSelected;
    AutoCompleteList *myList;
    id myTextView;
    NSInteger triggerIndex;
    id myScrollView;
    
    BOOL bAs;
    BOOL bDot;
    BOOL bBracket;
    
}



- (id) initWithCompletions: (NSArray *)completions : (NSTextView *)_myTextView :(NSRange) triggerRange :(BOOL) bAs :(BOOL) bDot :(BOOL) bBracket;
- (NSInteger) popupAssistantAt: (NSPoint)where forView: (NSTextView *)view;

- (void)showContextHelp:(id)sender;
- (void) updateTypeSelection;
- (void)myInsert:(id)sender: (NSString*) bracketChar;
- (id)myTextView;


- (NSInteger)numberOfRowsInTableView:(NSTableView *)aTableView;

- (id)tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *)tableColumn row:(NSInteger)row;
@end

@interface OBTask : NSObject
{
@public
    NSTask *mytask;
    NSString *sName;
    id target;
    BOOL stdoutEmpty;
    BOOL stderrEmpty;
    BOOL taskDidTerminate;
    
}
@property (readwrite, copy) NSString *sName;
@property (readwrite) id target;
@property (readwrite) NSTask *mytask;

- (void)finalize;
-(void)myinit;
- (id) task;

- (void) _cleanup;
- (void) _stop;



- (void) stdin:(id) m;




- (void) get_stdout:(NSNotification *)aNotification;
- (void) get_stderr:(NSNotification *)aNotification;
- (void) get_stopped:(NSNotification *)aNotification;

@end

@interface NSTextView(ObjB)

- (void)_ShouldChangeText:(id)array;

- (NSRange)delegate_textView:(NSTextView *)textView willChangeSelectionFromCharacterRange:(NSRange)oldSelectedCharRange toCharacterRange:(NSRange)newSelectedCharRange ;
- (NSArray *)delegate_textView:(NSTextView *)textView completions:(NSArray *) words forPartialWordRange:(NSRange)charRange indexOfSelectedItem:(NSInteger *)index ;
@end

@interface OBTextView : NSTextView
{
@public
    NSMutableArray *runningCompletions;
    NSMutableArray *_lineSeparators;
    NSMutableArray *_Breakpoints;
    NSMutableArray *_keywords;
    NSMutableArray *_builtins;
    NSMutableArray *_types;
    
    NSMutableString *sFilename;
    NSTimer *completionTimer;
    
    NSString *sCompletion;
    
    NSInteger nCompletionRunning;
    
    NSInteger nextInsertionIndex;
    NSInteger nextInsertionIndex2;
    NSInteger lastInsertionIndex;
    
    BOOL bAutoIndent;
    BOOL bAs;
    BOOL bClass;
    BOOL bBuiltin;
    int nIndent;
    
    BOOL findOptionIgnoreCase;
    BOOL findOptionSelectedTextOnly;
    BOOL findOptionWholeWordsOnly;
    
    NSPrintInfo *pi;
    NSString *sProjectName;
    NSString *sProjectFile;
    
}
- (void)PrintShowingPrintPanel:(NSString*) _sProjectName:(NSString*) _sProjectFile :(BOOL)flag;

- (NSMutableArray *)runningCompletions;
- (void)setCompletionType: (BOOL)_bAs : (BOOL)_bClass : (BOOL)_bBuiltin;

- (void)_myinit;
- (id)init;
- (id)initWithFrame:(NSRect)frameRect;

- (void)drawRect:(NSRect)rect;
- (void)insertTab:(id)sender;

- (void)keyUp:(NSEvent *) theEvent;

- (void)_ShouldChangeText:(id)array;

- (void)getCompletion:(NSInteger)loc :(NSString *)tsString;

- (void)setFindOptionIgnoreCase:(BOOL)k;
- (void)setFindOptionSelectedTextOnly:(BOOL)k;
- (void)setFindOptionWholeWordsOnly:(BOOL)k;

- (BOOL)findOptionIgnoreCase;
- (BOOL)findOptionSelectedTextOnly;
- (BOOL)findOptionWholeWordsOnly;


- (void)_lowercase;
- (void)_uppercase;
- (id)_selectedText;
- (void)_autoFormat;
- (void)_shiftLeft;
- (void)_shiftRight;
- (void)_comment;
- (void)_uncomment;

- (BOOL)_load:(NSMutableString*)k;
- (BOOL)_save:(NSMutableString*)k;
- (void)setFilename:(NSMutableString*)k;
- (NSMutableString *)filename;

- (void)keyDown:(NSEvent *)theEvent;

-(void) toggleBreakpoint;
-(void) turnOffWrapping;
-(void) turnOnAutoIndent;
- (void) performSyntaxHighlighting: (OBTextView *) textview : (BOOL) bALL;

- (void)setLineSeparators:(NSMutableArray*)k;
- (NSMutableArray *)lineSeparators;
- (void)setKeywords:(NSMutableArray*)k;
- (NSMutableArray *)keywords;
- (void)setBuiltins:(NSMutableArray*)k;
- (NSMutableArray *)builtins;
- (void)setTypes:(NSMutableArray*)k;
- (NSMutableArray *)types;

- (void)doCompletion:(NSTimer *)timer ;
- (void)startCompletionTimer ;
- (void)stopCompletionTimer ;
- (NSRange)delegate_textView:(NSTextView *)textView willChangeSelectionFromCharacterRange:(NSRange)oldSelectedCharRange toCharacterRange:(NSRange)newSelectedCharRange ;
- (NSArray *)delegate_textView:(NSTextView *)textView completions:(NSArray *) words forPartialWordRange:(NSRange)charRange indexOfSelectedItem:(NSInteger *)index ;

- (NSInteger) popupCompletionAtInsertion: (NSArray *)completionList :(NSRange) triggerRange;
- (NSPoint) insertionPointGlobalCoordinate;

@end

void OBJB_OBBACKGROUNDVIEW_SETBACKGROUNDGRADIENT(id obbackgroundview, id beginColor, id endColor);
void OBJB_OBBACKGROUNDVIEW_SETBACKGROUNDIMAGE(id obbackgroundview, id image, id alpha);
void OBJB_OBBACKGROUNDVIEW_SETBACKGROUNDCORNERRADIUS(id obbackgroundview, id radius);

//void OBJB_OBJBSETINTERFACEBUILDER(id _projectPath, id _projectName);


id OBJBS(const char * acCurrentFile, const char * acCurrentScope, const char * acCurrentLine, const char * acFlag);

id ObjBL();
id ObjBF();
id ObjBS();
//void DEBUG();
//void DEBUG_STEPINTO();
void ObjBB();
id   OBJB_IDNIL();
id   OBJB_ID(NSColor *m);
id   OBJB_ID(NSRect m);
id   OBJB_ID(NSPoint m);
id   OBJB_ID(NSSize m);
id   OBJB_ID(NSRange m);
id   OBJB_NSOBJECTNIL(id m);
id   OBJB_ID(id m);
id   OBJB_ID(NSMutableArray *m);
id   OBJB_ID(NSArray *m);
id   OBJB_ID(NSMutableDictionary *m);
id   OBJB_ID(NSDictionary *m);
id   OBJB_ID(NSMutableData *m);
id   OBJB_ID(NSData *m);
id   OBJB_ID(NSMutableString *m);
id   OBJB_ID(NSString *m);
id   OBJB_ID(BOOL m);
id   OBJB_ID(char m);
id   OBJB_ID(short m);
id   OBJB_ID(unsigned short m);
id   OBJB_ID(NSInteger m);
id   OBJB_ID(NSUInteger m);
id   OBJB_ID(long long m);
id   OBJB_ID(unsigned long long m);
id   OBJB_ID(float m);
id   OBJB_ID(double m);

//id   OBJB_ASSIGNMENT(id *l, id *r);
id   OBJB_EQUALEQUALEQUAL(id l, id r);
id   OBJB_EQUALEQUAL(id l, id r);
id   OBJB_EQUAL(id l, id r);
id   OBJB_UNEQUAL(id l, id r);
id   OBJB_SMALLER(id l, id r);
id   OBJB_GREATER(id l, id r);
id   OBJB_SMALLEREQUAL(id l, id r);
id   OBJB_GREATEREQUAL(id l, id r);
id   OBJB_FLIP(id l);
id   OBJB_NOT(id l);
id   OBJB_MINUS(id l);
id   OBJB_AND(id l, id r);
id   OBJB_OR(id l, id r);
id   OBJB_XOR(id l, id r);
id   OBJB_SHL(id l, id r);
id   OBJB_SHR(id l, id r);
id   OBJB_ANDALSO(id l, id r);
id   OBJB_ORELSE(id l, id r);
id   OBJB_ADD(id l, id r);
id   OBJB_SUB(id l, id r);
id   OBJB_CONCAT(id l, id r);
id   OBJB_MUL(id l, id r);
id   OBJB_IDIV(id l, id r);
id   OBJB_DIV(id l, id r);
id   OBJB_MOD(id l, id r);
id   OBJB_NSEVENT_INIT(id object, const char *Name_OnAction);
id   OBJB_NSEVENT_LOCATIONINWINDOW(id event);
id OBJB_NSEVENT_CHARACTERS(id event);
id   OBJB_NSEVENT_KEY(id event);

void OBJB_NSSCROLLVIEW_DOCUMENTVIEW(id scrollview, id Value);
id   OBJB_NSSCROLLVIEW_DOCUMENTVIEW(id scrollview);
void OBJB_NSSCROLLVIEW_CONTENTVIEW(id scrollview, id Value);
id   OBJB_NSSCROLLVIEW_CONTENTVIEW(id scrollview);

void OBJB_NSTEXT_FONT(id text, id Value);
id   OBJB_NSTEXT_FONT(id text);
void OBJB_NSTEXT_EDITABLE(id text, id Value);
id   OBJB_NSTEXT_EDITABLE(id text);

id   OBJB_NSTOOLBARITEM_INIT(id object, const char *Name_OnAction);
void OBJB_NSTOOLBARITEM_IMAGE(id toolbaritem, id Value);
id   OBJB_NSTOOLBARITEM_IMAGE(id toolbaritem);
void OBJB_NSTOOLBARITEM_LABEL(id toolbaritem, id Value);
id   OBJB_NSTOOLBARITEM_LABEL(id toolbaritem);
void OBJB_NSTOOLBARITEM_ITEMIDENTIFIER(id toolbaritem, id Value);
id   OBJB_NSTOOLBARITEM_ITEMIDENTIFIER(id toolbaritem);
void OBJB_NSTOOLBARITEM_PALETTELABEL(id toolbaritem, id Value);
id   OBJB_NSTOOLBARITEM_PALETTELABEL(id toolbaritem);
void OBJB_NSTOOLBARITEM_TOOLTIP(id toolbaritem, id Value);
id   OBJB_NSTOOLBARITEM_TOOLTIP(id toolbaritem);
void OBJB_NSTOOLBARITEM_TAG(id toolbaritem, id Value);
id   OBJB_NSTOOLBARITEM_TAG(id toolbaritem);
void OBJB_NSTOOLBARITEM_ENABLED(id toolbaritem, id Value);
id   OBJB_NSTOOLBARITEM_ENABLED(id toolbaritem);
void OBJB_NSTOOLBARITEM_VIEW(id toolbaritem, id Value);
id   OBJB_NSTOOLBARITEM_VIEW(id toolbaritem);
void OBJB_NSTOOLBARITEM_MINSIZE(id toolbaritem, id Value);
id   OBJB_NSTOOLBARITEM_MINSIZE(id toolbaritem);
void OBJB_NSTOOLBARITEM_MAXSIZE(id toolbaritem, id Value);
id   OBJB_NSTOOLBARITEM_MAXSIZE(id toolbaritem);

id   OBJB_NSTOOLBAR_INIT(id object, const char *Name_OnAction);
void OBJB_NSTOOLBAR_RUNCUSTOMIZATIONPALETTE(id toolbar);
void OBJB_NSTOOLBAR_SETSELECTEDITEMIDENTIFIER(id toolbar, id Value);
void OBJB_NSTOOLBAR_SHOW(id toolbar);
void OBJB_NSTOOLBAR_HIDE(id toolbar);
void OBJB_NSTOOLBAR_SHOWSBASELINESEPARATOR(id toolbar, id Value);
id   OBJB_NSTOOLBAR_SHOWSBASELINESEPARATOR(id toolbar);
void OBJB_NSTOOLBAR_ALLOWSUSERCUSTOMIZATION(id toolbar, id Value);
id   OBJB_NSTOOLBAR_ALLOWSUSERCUSTOMIZATION(id toolbar);
void OBJB_NSTOOLBAR_AUTOSAVESCONFIGURATION(id toolbar, id Value);
id   OBJB_NSTOOLBAR_AUTOSAVESCONFIGURATION(id toolbar);
void OBJB_NSTOOLBAR_DELEGATE(id toolbar, id Value);
id   OBJB_NSTOOLBAR_DELEGATE(id toolbar);
void OBJB_NSTOOLBAR_VISIBLE(id toolbar, id Value);
id   OBJB_NSTOOLBAR_VISIBLE(id toolbar);
void OBJB_NSTOOLBAR_DISPLAYMODE(id toolbar, id Value);
id   OBJB_NSTOOLBAR_DISPLAYMODE(id toolbar);
void OBJB_NSTOOLBAR_SIZEMODE(id toolbar, id Value);
id   OBJB_NSTOOLBAR_SIZEMODE(id toolbar);

id   OBJB_NSDRAWER_INIT(id object, const char *Name_OnAction);
void OBJB_NSDRAWER_TOGGLE(id   OBJB_NSdrawer);
void OBJB_NSDRAWER_TOGGLERIGHTRESIZINGWINDOW(id drawer);
void OBJB_NSDRAWER_PARENTWINDOW(id   OBJB_NSdrawer, id Value);
id   OBJB_NSDRAWER_PARENTWINDOW(id   OBJB_NSdrawer);

id   OBJB_NSIMAGECELL_INIT(id object, const char *Name_OnAction, id Image);
id   OBJB_NSIMAGECELL_INIT(id object, const char *Name_OnAction);

id   OBJB_NSCELL_INIT(id object, const char *Name_OnAction, id Value);
id   OBJB_NSCELL_INIT(id object, const char *Name_OnAction);

id   OBJB_NSBUTTONCELL_INIT(id object, const char *Name_OnAction);
void OBJB_NSBUTTONCELL_TITLE(id cell, id Value);
id   OBJB_NSBUTTONCELL_TITLE(id cell);

id   OBJB_NSPOPUPBUTTONCELL_INIT(id object, const char *Name_OnAction);
void OBJB_NSPOPUPBUTTONCELL_SELECT(id popupbuttoncell, id Value);
void OBJB_NSPOPUPBUTTONCELL_MENU(id popupbuttoncell, id Value);
id   OBJB_NSPOPUPBUTTONCELL_MENU(id popupbuttoncell);
id   OBJB_NSPOPUPBUTTONCELL_SELECTED(id popupbuttoncell);

void OBJB_NSSAVEPANEL_TITLE(id savepanel, id Value);
id   OBJB_NSSAVEPANEL_TITLE(id savepanel);

void OBJB_NSAPPLICATION_APPLICATIONICONIMAGE(id application, id Value);
id   OBJB_NSAPPLICATION_APPLICATIONICONIMAGE(id application);
id   OBJB_NSAPPLICATION_KEYWINDOW(id application);
id   OBJB_NSAPPLICATION_CURRENTEVENT(id application);
id   OBJB_NSAPPLICATION_MAINMENU(id application);
void OBJB_NSAPPLICATION_HIDESPOTLIGHTFORHELP(id application);
void OBJB_NSAPPLICATION_TERMINATE(id application, id sender);
void OBJB_NSAPPLICATION_HIDEOTHERAPPLICATIONS(id application, id sender);
void OBJB_NSAPPLICATION_UNHIDEALLAPPLICATIONS(id application, id sender);
void OBJB_NSAPPLICATION_SHOWOTHERAPPLICATION(id application, id PID);
void OBJB_NSAPPLICATION_ACTIVATEIGNORINGOTHERAPPS(id application, id Flag);

void OBJB_NSUSERDEFAULTS_REGISTERDEFAULTS(id   _self, id Defaults);
void OBJB_NSUSERDEFAULTS_SET(id   _self, id Key, id Value);
id   OBJB_NSUSERDEFAULTS_GET(id   _self, id Key);
void OBJB_NSUSERDEFAULTS_SYNCHRONIZE(id   _self);
void OBJB_NSUSERDEFAULTS_REMOVE(id   _self, id Key);

void OBJB_NSNOTIFICATIONCENTER_ADDOBSERVER(id _self, id ActionName, id ForSender);
void OBJB_NSNOTIFICATIONCENTER_REMOVEOBSERVER(id _self, id ActionName, id ForSender);
void OBJB_NSNOTIFICATIONCENTER_POSTNOTIFICATIONNAME(id _self, id ActionName, id UserInfo);

/*
id OBJB_DEBUG_LINE(id _self);
id OBJB_DEBUG_CLASSNAME(id _self);
id OBJB_DEBUG_SUPERCLASSNAME(id _self);
id OBJB_DEBUG_FILE(id _self);
id OBJB_DEBUG_SCOPE(id _self);
id OBJB_DEBUG_INFO(id _self);

void OBJB_TRACE();
*/

id   OBJB_NSPROCESSINFO_ARGUMENTS(id _self);
id   OBJB_NSPROCESSINFO_ENVIRONMENT(id _self);
id   OBJB_NSPROCESSINFO_PID(id _self);




id OBJB_DEBUG_LINE(id _self);
id OBJB_DEBUG_CLASSNAME(id _self);
id OBJB_DEBUG_SUPERCLASSNAME(id _self);
id OBJB_DEBUG_FILE(id _self);
id OBJB_DEBUG_SCOPE(id _self);
id OBJB_DEBUG_INFO(id _self);


id OBJB_CMATH_SIN(id _self, id l);
id OBJB_CMATH_COS(id _self, id l);
id OBJB_CMATH_TAN(id _self, id l);
id OBJB_CMATH_ASIN(id _self, id l);
id OBJB_CMATH_ACOS(id _self, id l);
id OBJB_CMATH_ATAN(id _self, id l);
id OBJB_CMATH_ATAN2(id _self, id l, id r);
id OBJB_CMATH_SINH(id _self, id l);
id OBJB_CMATH_COSH(id _self, id l);
id OBJB_CMATH_TANH(id _self, id l);
id OBJB_CMATH_EXP(id _self, id l);
id OBJB_CMATH_LOG(id _self, id l);
id OBJB_CMATH_LOG2(id _self, id l);
id OBJB_CMATH_LOG10(id _self, id l);
id OBJB_CMATH_SQRT(id _self, id l);
id OBJB_CMATH_CEIL(id _self, id l);
id OBJB_CMATH_FLOOR(id _self, id l);
id OBJB_CMATH_FABS(id _self, id l);
id OBJB_CMATH_POW(id _self, id l, id r);
id OBJB_CMATH_HYPOT(id _self, id l, id r);
id OBJB_CMATH_ROUND(id _self, id l);
id OBJB_CMATH_ACOSH(id _self, id l);
id OBJB_CMATH_ASINH(id _self, id l);
id OBJB_CMATH_ATANH(id _self, id l);
id OBJB_CMATH_EXPM1(id _self, id l);
id OBJB_CMATH_LOG1P(id _self, id l);
id OBJB_CMATH_LOGB(id _self, id l);
id OBJB_CMATH_SCALB(id _self, id l, id r);
id OBJB_CMATH_ERF(id _self, id l);
id OBJB_CMATH_ERFC(id _self, id l);
id OBJB_CMATH_GAMMA(id _self, id l);
id OBJB_CMATH_LGAMMA(id _self, id l);
id OBJB_CMATH_RINT(id _self, id l);
id OBJB_CMATH_NEARBYINT(id _self, id l);
id OBJB_CMATH_RINTTOL(id _self, id l);
id OBJB_CMATH_TRUNC(id _self, id l);
id OBJB_CMATH_REMAINDER(id _self, id l, id r);
id OBJB_CMATH_ISNORMAL(id _self, id l);
id OBJB_CMATH_ISFINITE(id _self, id l);
id OBJB_CMATH_ISNAN(id _self, id l);
id OBJB_CMATH_FDIM(id _self, id l, id r);
id OBJB_CMATH_COMPOUND(id _self, id l, id r);
id OBJB_CMATH_ANNUITY(id _self, id l, id r);




id   OBJB_USER_FULLUSERNAME(id _self);
id   OBJB_USER_HOMEDIRECTORY(id _self);
id   OBJB_USER_DESKTOPDIRECTORY(id _self);
id   OBJB_USER_TEMPORARYDIRECTORY(id _self);
id   OBJB_USER_USERNAME(id _self);
id   OBJB_USER_HOMEDIRECTORYFORUSER(id _self, id Value);

id   OBJB_NSBUNDLE_RESOURCEPATH(id _self);
id   OBJB_NSBUNDLE_BUNDLEPATH(id _self);
id   OBJB_NSBUNDLE_EXECUTABLEPATH(id _self);

id   OBJB_FILE_COPY(id _file, id From, id To);
id   OBJB_FILE_MOVE(id _file, id From, id To);
id   OBJB_FILE_REMOVEFILE(id _file, id From);
id   OBJB_FILE_CREATEFILE(id _file, id From);
id   OBJB_FILE_CREATEDIR(id _file, id From);
id   OBJB_FILE_LIST(id _file, id From);

id OBJB_NSOBJECT_INIT(id _object);
id OBJB_NSOBJECT_ISKINDOFCLASS(id _object, id r);
id OBJB_NSOBJECT_ISMEMBEROFCLASS(id _object, id r);
id OBJB_NSOBJECT_RESPONDSTOSELECTOR(id _object, id r);
id OBJB_NSOBJECT_INSTANCESRESPONDSTOSELECTOR(id _object, id r);

id   OBJB_NSOBJECT_LOADNIB(id _object, id NibName);
id   OBJB_NSOBJECT_PERFORMSELECTOR0(id _object, id SelectorName);
id   OBJB_NSOBJECT_PERFORMSELECTOR1(id _object, id SelectorName, id Argument);
id   OBJB_NSOBJECT_PERFORMSELECTOR2(id _object, id SelectorName, id Argument, id Argument2);
void OBJB_NSOBJECT_PERFORMSELECTORDELAYED(id _object, id SelectorName, id Argument, id Seconds);
void OBJB_NSOBJECT_PERFORMSELECTORNEXTRUNLOOP(id _object, id SelectorName, id Argument, id Seconds);
void OBJB_NSOBJECT_PERFORMSELECTORONMAINTHREAD(id _object, id SelectorName, id Argument, id waitUntilDone);
void OBJB_NSOBJECT_BIND(id _object, id Binding, id ToObject, id WithKeyPath, id Options);
void OBJB_NSOBJECT_UNBIND(id _object, id Binding);
void OBJB_NSOBJECT_SETVALUEFORKEY(id _object, id Value, id Key);
id   OBJB_NSOBJECT_VALUEFORKEYPATH(id _object, id KeyPath);

id   OBJB_FIRSTRESPONDER_SENDACTION(id firstresponder, id Value);
id   OBJB_FIRSTRESPONDER_SENDACTION2(id firstresponder, id Value, id Sender);
void OBJB_OPENPANEL_Init();

void OBJB_NSOPENPANEL_CANCHOOSEFILES(id openpanel, id Value);
id   OBJB_NSOPENPANEL_CANCHOOSEFILES(id openpanel);
void OBJB_NSOPENPANEL_CANCHOOSEDIRECTORIES(id openpanel, id Value);
id   OBJB_NSOPENPANEL_CANCHOOSEDIRECTORIES(id openpanel);
void OBJB_NSOPENPANEL_RESOLVESALIASES(id openpanel, id Value);
id   OBJB_NSOPENPANEL_RESOLVESALIASES(id openpanel);
void OBJB_NSOPENPANEL_ALLOWSMULTIPLESELECTION(id openpanel, id Value);
id OBJB_NSOPENPANEL_ALLOWSMULTIPLESELECTION(id openpanel);
void OBJB_NSOPENPANEL_DIRECTORY(id openpanel, id Value);
id   OBJB_NSOPENPANEL_DIRECTORY(id openpanel);
void OBJB_NSOPENPANEL_FILE(id openpanel, id Value);
id   OBJB_NSOPENPANEL_FILE(id openpanel);
void OBJB_NSOPENPANEL_TYPES(id openpanel, id Value);
id   OBJB_NSOPENPANEL_TYPES(id openpanel);
id   OBJB_NSOPENPANEL_RUN(id openpanel);
id   OBJB_NSOPENPANEL_FILENAMES(id openpanel);
id   OBJB_NSOPENPANEL_URLS(id openpanel);
id   OBJB_NSOPENPANEL_FILENAME(id openpanel);
id   OBJB_NSOPENPANEL_URL(id openpanel);

id   OBJB_NSMATRIX_INIT(id object, const char *Name_OnAction);
id   OBJB_NSMATRIX_SELECTEDCELL(id matrix);
void OBJB_NSMATRIX_ADDROW(id matrix, id Value);
void OBJB_NSMATRIX_MODE(id matrix, id Value);
id   OBJB_NSMATRIX_MODE(id matrix);
void OBJB_NSMATRIX_DRAWSBACKGROUND(id matrix, id Value);
id   OBJB_NSMATRIX_DRAWSBACKGROUND(id matrix);
void OBJB_NSMATRIX_DRAWSCELLBACKGROUND(id matrix, id Value);
id   OBJB_NSMATRIX_DRAWSCELLBACKGROUND(id matrix);

id OBJB_NSTABLECOLUMN_INIT(id object, const char *Name_OnAction, id Identifier, id Title);
id   OBJB_NSTABLECOLUMN_INIT(id object, const char *Name_OnAction);
void OBJB_NSTABLECOLUMN_RESIZINGMASK(id tablecolumn, id Value);
id   OBJB_NSTABLECOLUMN_RESIZINGMASK(id tablecolumn);
void OBJB_NSTABLECOLUMN_IDENTIFIER(id tablecolumn, id Value);
id   OBJB_NSTABLECOLUMN_IDENTIFIER(id tablecolumn);
void OBJB_NSTABLECOLUMN_TITLE(id tablecolumn, id Value);
id   OBJB_NSTABLECOLUMN_TITLE(id tablecolumn);
void OBJB_NSTABLECOLUMN_DATACELL(id tablecolumn, id Value);
id   OBJB_NSTABLECOLUMN_DATACELL(id tablecolumn);
void OBJB_NSTABLECOLUMN_MAXWIDTH(id tablecolumn, id Value);
id   OBJB_NSTABLECOLUMN_MAXWIDTH(id tablecolumn);
void OBJB_NSTABLECOLUMN_MINWIDTH(id tablecolumn, id Value);
id   OBJB_NSTABLECOLUMN_MINWIDTH(id tablecolumn);
void OBJB_NSTABLECOLUMN_WIDTH(id tablecolumn, id Value);
id   OBJB_NSTABLECOLUMN_WIDTH(id tablecolumn);
void OBJB_NSTABLECOLUMN_EDITABLE(id tablecolumn, id Value);
id   OBJB_NSTABLECOLUMN_EDITABLE(id tablecolumn);
void OBJB_NSTABLECOLUMN_VISIBLE(id tablecolumn, id Value);
id   OBJB_NSTABLECOLUMN_VISIBLE(id tablecolumn);

id OBJB_NSMENUITEM_INIT(id object, const char *Name_OnAction, id Title);
id   OBJB_NSMENUITEM_INIT(id object, const char *Name_OnAction);
void OBJB_NSMENUITEM_ACTIONNAME(NSMenuItem  *menuitem, id Value);
id   OBJB_NSMENUITEM_ACTIONNAME(id menuitem);
void OBJB_NSMENUITEM_TARGET(id menuitem, id Value);
id   OBJB_NSMENUITEM_TARGET(id menuitem);
void OBJB_NSMENUITEM_REPRESENTEDOBJECT(id menuitem, id Value);
id   OBJB_NSMENUITEM_REPRESENTEDOBJECT(id menuitem);
void OBJB_NSMENUITEM_SUBMENU(id menuitem, id Value);
id   OBJB_NSMENUITEM_SUBMENU(id menuitem);
void OBJB_NSMENUITEM_TITLE(id menuitem, id Value);
id   OBJB_NSMENUITEM_TITLE(id menuitem);
void OBJB_NSMENUITEM_ATTRIBUTEDTITLE(id menuitem, id Value);
id   OBJB_NSMENUITEM_ATTRIBUTEDTITLE(id menuitem);
void OBJB_NSMENUITEM_TAG(id menuitem, id Value);
id   OBJB_NSMENUITEM_TAG(id menuitem);
void OBJB_NSMENUITEM_IMAGE(id menuitem, id Value);
id   OBJB_NSMENUITEM_IMAGE(id menuitem);
void OBJB_NSMENUITEM_STATE(id menuitem, id Value);
id   OBJB_NSMENUITEM_STATE(id menuitem);
void OBJB_NSMENUITEM_HIDDEN(id menuitem, id Value);
id   OBJB_NSMENUITEM_HIDDEN(id menuitem);
void OBJB_NSMENUITEM_ENABLED(id menuitem, id Value);
id   OBJB_NSMENUITEM_ENABLED(id menuitem);
void OBJB_NSMENUITEM_KEYEQUIVALENT(id menuitem, id Value);
id   OBJB_NSMENUITEM_KEYEQUIVALENT(id menuitem);
void OBJB_NSMENUITEM_KEYEQUIVALENTMODIFIERMASK(id menuitem, id Value);
id   OBJB_NSMENUITEM_KEYEQUIVALENTMODIFIERMASK(id menuitem);

id   OBJB_NSMENU_INIT(id object, const char *Name_OnAction, id Title);
id   OBJB_NSMENU_INIT(id object, const char *Name_OnAction);
void OBJB_NSMENU_REMOVEALL(id menu);
id   OBJB_NSMENU_COUNT(id menu);
id   OBJB_NSMENU_ARRAY(id menu);
id   OBJB_NSMENU_MENUITEMWITHTAG(id menu, id Value);
id   OBJB_NSMENU_MENUITEM(id menu, id Value);
void OBJB_NSMENU_PREPENDMENU(id menu, id Value);
void OBJB_NSMENU_REMOVE(id menu, id Value);
void OBJB_NSMENU_INSERTSEPARATOR(id menu, id Index);
void OBJB_NSMENU_INSERTMENUITEM(id menu, id Value, id Index);
void OBJB_NSMENU_INSERTMENU(id menu, id Value, id Index);
void OBJB_NSMENU_PREPENDMENUITEM(id menu, id Value);
void OBJB_NSMENU_PREPENDSEPARATOR(id menu);
void OBJB_NSMENU_APPENDMENU(id menu, id Value);
void OBJB_NSMENU_APPENDMENUITEM(id menu, id Value);
void OBJB_NSMENU_APPENDSEPARATOR(id menu);
void OBJB_NSMENU_APPEND(id menu, id Value);
void OBJB_NSMENU_TITLE(id menu, id Value);
id   OBJB_NSMENU_TITLE(id menu);
void OBJB_NSMENU_DELEGATE(id menu, id Value);
id   OBJB_NSMENU_DELEGATE(id menu);

void OBJB_NSRESPONDER_NEXTRESPONDER(id responder, id Value);
id   OBJB_NSRESPONDER_NEXTRESPONDER(id responder);
void OBJB_NSRESPONDER_MENU(id responder, id Value);
id   OBJB_NSRESPONDER_MENU(id responder);
id   OBJB_NSRESPONDER_ACCEPTSFIRSTRESPONDER(id responder);

id   OBJB_NSWINDOW_INIT(id object, const char *Name_OnAction);
void OBJB_NSWINDOW_MOVE(id window, id Value);
void OBJB_NSWINDOW_SETTOOLBAR(id window, id Value);
id   OBJB_NSWINDOW_TOOLBAR(id window);
void OBJB_NSWINDOW_MAKEMAINWINDOW(id window);
void OBJB_NSWINDOW_DOCUMENTICON(id window, id Value);
id   OBJB_NSWINDOW_DOCUMENTICON(id window);
void OBJB_NSWINDOW_RELEASEDWHENCLOSED(id window, id Value);
id   OBJB_NSWINDOW_RELEASEDWHENCLOSED(id window);
void OBJB_NSWINDOW_SELECTKEYVIEWFOLLOWINGVIEW(id window, id Value);
void OBJB_NSWINDOW_SELECTKEYVIEWPRECEDINGVIEW(id window, id Value);
void OBJB_NSWINDOW_SELECTNEXTKEYVIEW(id window);
void OBJB_NSWINDOW_SELECTPREVIOUSKEYVIEW(id window);
void OBJB_NSWINDOW_DELEGATE(id window, id Value);
id   OBJB_NSWINDOW_DELEGATE(id window);
void OBJB_NSWINDOW_CONTENTSIZE(id window, id Value);
id   OBJB_NSWINDOW_CONTENTSIZE(id window);
void OBJB_NSWINDOW_SHOWSTOOLBARBUTTON(id window, id Value);
id   OBJB_NSWINDOW_SHOWSTOOLBARBUTTON(id window);
void OBJB_NSWINDOW_SHOWSRESIZEINDICATOR(id window, id Value);
id   OBJB_NSWINDOW_SHOWSRESIZEINDICATOR(id window);
void OBJB_NSWINDOW_TITLE(id window, id Value);
id   OBJB_NSWINDOW_TITLE(id window);
void OBJB_NSWINDOW_SHOW(id window);
void OBJB_NSWINDOW_HIDE(id window);
void OBJB_NSWINDOW_DEMINIATURIZE(id window);
void OBJB_NSWINDOW_DISPLAYIFNEEDED(id window);
void OBJB_NSWINDOW_DISABLEKEYEQUIVALENTFORDEFAULTBUTTONCELL(id window);
void OBJB_NSWINDOW_ENABLEKEYEQUIVALENTFORDEFAULTBUTTONCELL(id window);
void OBJB_NSWINDOW_CENTERANDSHOW(id window);
void OBJB_NSWINDOW_CENTER(id window);
void OBJB_NSWINDOW_ZOOM(id window);
void OBJB_NSWINDOW_CLOSE(id window);
void OBJB_NSWINDOW_MINIATURIZE(id window);
void OBJB_NSWINDOW_ORDERFRONT(id window);
void OBJB_NSWINDOW_ORDERFRONTREGARDLESS(id window);
void OBJB_NSWINDOW_ORDERBACK(id window);
void OBJB_NSWINDOW_RUNTOOLBARCUSTOMIZATIONPALETTE(id window);
void OBJB_NSWINDOW_RECALCULATEKEYVIEWLOOP(id window);
void OBJB_NSWINDOW_MAKEKEYANDORDERFRONT(id window);
void OBJB_NSWINDOW_MAKEKEYWINDOW(id window);
id   OBJB_NSWINDOW_MINFRAMEWIDTHWITHTITLE(id window, id Value);
id   OBJB_NSWINDOW_CONTENTRECTFORFRAMERECT(id window, id Value);
id   OBJB_NSWINDOW_FRAMERECTFORCONTENTRECT(id window, id Value);
id   OBJB_NSWINDOW_FIRSTRESPONDER(id window);
void OBJB_NSWINDOW_APPEND(id window, id Value);
void OBJB_NSWINDOW_FRAME(id window, id Value);
id   OBJB_NSWINDOW_FRAME(id window);
void OBJB_NSWINDOW_STYLEMASK(id window, id Value);
id OBJB_NSWINDOW_STYLEMASK(id window);
void OBJB_NSWINDOW_X(id window, id Value);
id   OBJB_NSWINDOW_X(id window);
void OBJB_NSWINDOW_Y(id window, id Value);
id   OBJB_NSWINDOW_Y(id window);
void OBJB_NSWINDOW_WIDTH(id window, id Value);
id   OBJB_NSWINDOW_WIDTH(id window);
void OBJB_NSWINDOW_HEIGHT(id window, id Value);
id   OBJB_NSWINDOW_HEIGHT(id window);
void OBJB_NSWINDOW_CANHIDE(id window, id Value);
id   OBJB_NSWINDOW_CANHIDE(id window);
void OBJB_NSWINDOW_HASSHADOW(id window, id Value);
id   OBJB_NSWINDOW_HASSHADOW(id window);
void OBJB_NSWINDOW_HIDESONDEACTIVATE(id window, id Value);
id   OBJB_NSWINDOW_HIDESONDEACTIVATE(id window);
id   OBJB_NSWINDOW_MAKEFIRSTRESPONDER(id window, id Value);
void OBJB_NSWINDOW_INITIALFIRSTRESPONDER(id window, id Value);
id   OBJB_NSWINDOW_INITIALFIRSTRESPONDER(id window);
id   OBJB_NSWINDOW_ISKEYWINDOW(id window);
id   OBJB_NSWINDOW_ISMAINWINDOW(id window);
id   OBJB_NSWINDOW_ISMINIATURIZED(id window);
id   OBJB_NSWINDOW_ISVISIBLE(id window);
id   OBJB_NSWINDOW_ISZOOMED(id window);
void OBJB_NSWINDOW_VISIBLE(id window, id Value);
id   OBJB_NSWINDOW_VISIBLE(id window);
void OBJB_NSWINDOW_MOVABLEBYWINDOWBACKGROUND(id window, id Value);
id   OBJB_NSWINDOW_MOVABLEBYWINDOWBACKGROUND(id window);
void OBJB_NSWINDOW_ACCEPTSMOUSEMOVEDEVENTS(id window, id Value);
id   OBJB_NSWINDOW_ACCEPTSMOUSEMOVEDEVENTS(id window);
void OBJB_NSWINDOW_ALLOWSTOOLTIPSWHENAPPLICATIONISINACTIVE(id window, id Value);
id   OBJB_NSWINDOW_ALLOWSTOOLTIPSWHENAPPLICATIONISINACTIVE(id window);
id   OBJB_NSWINDOW_CONVERTBASETOSCREEN(id window, id Value);
id   OBJB_NSWINDOW_CONVERTSCREENTOBASE(id window, id Value);
void OBJB_NSWINDOW_CONTENTMAXSIZE(id window, id Value);
id   OBJB_NSWINDOW_CONTENTMAXSIZE(id window);
void OBJB_NSWINDOW_CONTENTMINSIZE(id window, id Value);
id   OBJB_NSWINDOW_CONTENTMINSIZE(id window);
void OBJB_NSWINDOW_MAXSIZE(id window, id Value);
id   OBJB_NSWINDOW_MAXSIZE(id window);
void OBJB_NSWINDOW_MINSIZE(id window, id Value);
id   OBJB_NSWINDOW_MINSIZE(id window);
void OBJB_NSWINDOW_DEFAULTBUTTONCELL(id window, id Value);
id   OBJB_NSWINDOW_DEFAULTBUTTONCELL(id window);
void OBJB_NSWINDOW_BACKGROUNDCOLOR(id window, id Value);
id   OBJB_NSWINDOW_BACKGROUNDCOLOR(id window);
void OBJB_NSWINDOW_CONTENTVIEW(id window, id Value);
id   OBJB_NSWINDOW_CONTENTVIEW(id window);
void OBJB_NSWINDOW_OPAQUE(id window, id Value);
id   OBJB_NSWINDOW_OPAQUE(id window);
void OBJB_NSWINDOW_ALPHAVALUE(id window, id Value);
id   OBJB_NSWINDOW_ALPHAVALUE(id window);

id   OBJB_NSPANEL_INIT(id object, const char *Name_OnAction);
void OBJB_NSPANEL_FLOATINGPANEL(id panel, id Value);
id   OBJB_NSPANEL_FLOATINGPANEL(id panel);

id   OBJB_NSDATA_COUNT(id data);

id   OBJB_NSMUTABLEDATA_COUNT(id data);

id   OBJB_NSARRAY_COUNT(id array);
id   OBJB_NSARRAY_CONTAINS(id array, id Value);
id   OBJB_NSARRAY_OBJECT(id array, id Value);

id   OBJB_NSMUTABLEARRAY_COUNT(id array);
void OBJB_NSMUTABLEARRAY_REMOVEALL(id array);
void OBJB_NSMUTABLEARRAY_APPEND(id array, id Value);
id   OBJB_NSMUTABLEARRAY_CONTAINS(id array, id Value);
id   OBJB_NSMUTABLEARRAY_OBJECT(id array, id Value);
void OBJB_NSMUTABLEARRAY_REMOVE(id array, id Value);
void OBJB_NSMUTABLEARRAY_REMOVEOBJECT(id array, id Value);
void OBJB_NSMUTABLEARRAY_INSERT(id array, id Value, id Index);
void OBJB_NSMUTABLEARRAY_REPLACE(id array, id Value, id Index);

id   OBJB_NSDICTIONARY_COUNT(id dictionary);

id   OBJB_NSMUTABLEDICTIONARY_COUNT(id dictionary);
void OBJB_NSMUTABLEDICTIONARY_REMOVEALL(id dictionary);
void OBJB_NSMUTABLEDICTIONARY_REMOVE(id dictionary, id Key);
void OBJB_NSMUTABLEDICTIONARY_APPEND(id dictionary, id Key, id Value);
void OBJB_NSMUTABLEDICTIONARY_INSERT(id dictionary, id Key, id Value);
void OBJB_NSMUTABLEDICTIONARY_REPLACE(id dictionary, id Key, id Value);

id   OBJB_NSDICTIONARY_KEYS(id dictionary);
id   OBJB_NSMUTABLEDICTIONARY_KEYS(id dictionary);
id   OBJB_NSDICTIONARY_VALUES(id dictionary);
id   OBJB_NSMUTABLEDICTIONARY_VALUES(id dictionary);
id   OBJB_NSDICTIONARY_OBJECT(id dictionary, id Key);
id   OBJB_NSMUTABLEDICTIONARY_OBJECT(id dictionary, id Key);
id   OBJB_NSDICTIONARY_VALUE(id dictionary, id Key);
id   OBJB_NSMUTABLEDICTIONARY_VALUE(id dictionary, id Key);
id   OBJB_NSDICTIONARY_KEY(id dictionary, id Key);
id   OBJB_NSMUTABLEDICTIONARY_KEY(id dictionary, id Key);
id   OBJB_NSDICTIONARY_CONTAINS(id dictionary, id Key);
id   OBJB_NSMUTABLEDICTIONARY_CONTAINS(id dictionary, id Key);

id   OBJB_NSFILEMANAGER_INIT(id object, const char *Name_OnAction);
void OBJB_NSFILEMANAGER_PATH(id filemanager, id Value);
id   OBJB_NSFILEMANAGER_PATH(id filemanager);
id   OBJB_NSFILEMANAGER_LIST(id filemanager, id Path);
id   OBJB_NSFILEMANAGER_DELETE(id filemanager, id Path);
id   OBJB_NSFILEMANAGER_CREATEFILE(id filemanager, id Path);
id   OBJB_NSFILEMANAGER_CREATEDIRECTORY(id filemanager, id Path);
id   OBJB_NSFILEMANAGER_EXISTS(id filemanager, id Path);
id   OBJB_NSFILEMANAGER_EXISTSFILE(id filemanager, id Path);
id   OBJB_NSFILEMANAGER_EXISTSDIRECTORY(id filemanager, id Path);
id   OBJB_NSFILEMANAGER_ISREADABLE(id filemanager, id Path);
id   OBJB_NSFILEMANAGER_ISWRITABLE(id filemanager, id Path);
id   OBJB_NSFILEMANAGER_ISEXECUTABLE(id filemanager, id Path);
id   OBJB_NSFILEMANAGER_ISDELETABLE(id filemanager, id Path);
id   OBJB_NSFILEMANAGER_CREATE(id filemanager, id Path, id Data);
id   OBJB_NSFILEMANAGER_MOVE(id filemanager, id Path, id To);
id   OBJB_NSFILEMANAGER_COPY(id filemanager, id Path, id To);
id   OBJB_NSFILEMANAGER_LINK(id filemanager, id Path, id To);
/*
id   OBJB_MOVIEVIEW_INIT(id object, const char *Name_OnAction);
id   OBJB_PDFVIEW_INIT(id object, const char *Name_OnAction);
id   OBJB_WEBVIEW_INIT(id object, const char *Name_OnAction);
*/
id   OBJB_NSBROWSER_INIT(id object, const char *Name_OnAction);

id   OBJB_NSTABLEVIEW_INIT(id object, const char *Name_OnAction);
void OBJB_NSTABLEVIEW_DOUBLEACTIONNAME(id tableview, id Value);
id   OBJB_NSTABLEVIEW_DOUBLEACTIONNAME(id tableview);
id   OBJB_NSTABLEVIEW_CLICKEDROW(id tableview);
id   OBJB_NSTABLEVIEW_SELECTEDROW(id tableview);
id   OBJB_NSTABLEVIEW_COUNT(id tableview);
void OBJB_NSTABLEVIEW_SELECTROW(id tableview, id Value);
void OBJB_NSTABLEVIEW_APPEND(id tableview, id Value);
void OBJB_NSTABLEVIEW_RELOADDATA(id tableview);
void OBJB_NSTABLEVIEW_USESALTERNATINGROWBACKGROUNDCOLORS(id tableview, id Value);
id   OBJB_NSTABLEVIEW_USESALTERNATINGROWBACKGROUNDCOLORS(id tableview);
void OBJB_NSTABLEVIEW_DELEGATE(id tableview, id Value);
id   OBJB_NSTABLEVIEW_DELEGATE(id tableview);
void OBJB_NSTABLEVIEW_DATASOURCE(id tableview, id Value);
id   OBJB_NSTABLEVIEW_DATASOURCE(id tableview);
void OBJB_NSTABLEVIEW_TARGET(id tableview, id Value);
id   OBJB_NSTABLEVIEW_TARGET(id tableview);
void OBJB_NSTABLEVIEW_GRIDSTYLEMASK(id tableview, id Value);
id   OBJB_NSTABLEVIEW_GRIDSTYLEMASK(id tableview);
void OBJB_NSTABLEVIEW_HEADERVIEW(id tableview, id Value);
id   OBJB_NSTABLEVIEW_HEADERVIEW(id tableview);
void OBJB_NSTABLEVIEW_ROWHEIGHT(id tableview, id Value);
id   OBJB_NSTABLEVIEW_ROWHEIGHT(id tableview);

id   OBJB_NSOUTLINEVIEW_INIT(id object, const char *Name_OnAction);
id OBJB_VERTICALLINE_INIT(id object, const char *Name_OnAction);
id OBJB_HORIZONTALLINE_INIT(id object, const char *Name_OnAction);

id   OBJB_NSBOX_INIT(id object, const char *Name_OnAction);
void OBJB_NSBOX_BOXTYPE(id box, id Value);
id   OBJB_NSBOX_BOXTYPE(id box);
void OBJB_NSBOX_TITLE(id box, id Value);
id   OBJB_NSBOX_TITLE(id box);
void OBJB_NSBOX_BORDERTYPE(id box, id Value);
id   OBJB_NSBOX_BORDERTYPE(id box);
void OBJB_NSBOX_FILLCOLOR(id box, id Value);
id   OBJB_NSBOX_FILLCOLOR(id box);

id   OBJB_NSTABVIEW_INIT(id object, const char *Name_OnAction);
void OBJB_NSTABVIEW_SELECT(id   OBJB_NStabview, id Index);

id   OBJB_NSSCROLLVIEW_INIT(id object, const char *Name_OnAction);
void OBJB_NSSCROLLVIEW_DRAWSBACKGROUND(id scrollview, id Value);
id   OBJB_NSSCROLLVIEW_DRAWSBACKGROUND(id scrollview);
void OBJB_NSSCROLLVIEW_HASVERTICALSCROLLER(id scrollview, id Value);
id   OBJB_NSSCROLLVIEW_HASVERTICALSCROLLER(id scrollview);
void OBJB_NSSCROLLVIEW_HASHORIZONTALSCROLLER(id scrollview, id Value);
id   OBJB_NSSCROLLVIEW_HASHORIZONTALSCROLLER(id scrollview);
void OBJB_NSSCROLLVIEW_AUTOHIDESSCROLLERS(id scrollview, id Value);
id   OBJB_NSSCROLLVIEW_AUTOHIDESSCROLLERS(id scrollview);

id OBJB_VERTICALSPLITVIEW_INIT(id object, const char *Name_OnAction);
id OBJB_HORIZONTALSPLITVIEW_INIT(id object, const char *Name_OnAction);
id   OBJB_NSSPLITVIEW_INIT(id object, const char *Name_OnAction);

void OBJB_NSCURSOR_SET(id cursor);

void OBJB_NSCONTROL_ACTIONNAME(id control, id Value);
void OBJB_NSCONTROL_SIZETOFIT(id control);
id   OBJB_NSCONTROL_ACTIONNAME(id control);
void OBJB_NSCONTROL_TARGET(id control, id Value);
id   OBJB_NSCONTROL_TARGET(id control);
void OBJB_NSCONTROL_DELEGATE(id control, id Value);
id   OBJB_NSCONTROL_DELEGATE(id control);
void OBJB_NSCONTROL_CELL(id control, id Value);
id   OBJB_NSCONTROL_CELL(id control);
void OBJB_NSCONTROL_FONT(id control, id Value);
id   OBJB_NSCONTROL_FONT(id control);
void OBJB_NSCONTROL_ENABLED(id control, id Value);
id   OBJB_NSCONTROL_ENABLED(id control);
void OBJB_NSCONTROL_DOUBLEVALUE(id control, id Value);
id   OBJB_NSCONTROL_DOUBLEVALUE(id control);
void OBJB_NSCONTROL_SINGLEVALUE(id control, id Value);
id   OBJB_NSCONTROL_SINGLEVALUE(id control);
void OBJB_NSCONTROL_INTEGERVALUE(id control, id Value);
id   OBJB_NSCONTROL_INTEGERVALUE(id control);
void OBJB_NSCONTROL_OBJECTVALUE(id control, id Value);
id   OBJB_NSCONTROL_OBJECTVALUE(id control);
void OBJB_NSCONTROL_STRINGVALUE(id control, id Value);
id   OBJB_NSCONTROL_STRINGVALUE(id control);
void OBJB_NSCONTROL_ATTRIBUTEDSTRINGVALUE(id control, id Value);
id   OBJB_NSCONTROL_ATTRIBUTEDSTRINGVALUE(id control);
void OBJB_NSCONTROL_ALIGNMENT(id control, id Value);
id   OBJB_NSCONTROL_ALIGNMENT(id control);
void OBJB_NSCONTROL_TAG(id control, id Value);
id   OBJB_NSCONTROL_TAG(id control);
void OBJB_NSCONTROL_REFUSESFIRSTRESPONDER(id control, id Value);
id   OBJB_NSCONTROL_REFUSESFIRSTRESPONDER(id control);

id   OBJB_CUSTOMVIEW_INIT(id object, const char *Name_OnAction);

id   OBJB_NSVIEW_INIT(id object, const char *Name_OnAction);
void OBJB_NSVIEW_APPEND(id _view, id Value);
void OBJB_NSVIEW_REMOVE(id _view, id Value);
void OBJB_NSVIEW_REPLACE(id _view, id Old, id New);
void OBJB_NSVIEW_DRAWRECT(id _view, id Value);
void OBJB_NSVIEW_REDRAW(id _view);
void OBJB_NSVIEW_MOVE(id _view, id Value);
void OBJB_NSVIEW_RESIZE(id _view, id Value);
void OBJB_NSVIEW_AUTORESIZESSUBVIEWS(id _view, id Value);
id   OBJB_NSVIEW_AUTORESIZESSUBVIEWS(id _view);
void OBJB_NSVIEW_AUTORESIZINGMASK(id _view, id Value);
id   OBJB_NSVIEW_AUTORESIZINGMASK(id _view);
void OBJB_NSVIEW_FOCUSRINGTYPE(id _view, id Value);
id   OBJB_NSVIEW_FOCUSRINGTYPE(id _view);
void OBJB_NSVIEW_NEXTKEYVIEW(id _view, id Value);
id   OBJB_NSVIEW_NEXTKEYVIEW(id _view);
void OBJB_NSVIEW_SHOW(id _view);
void OBJB_NSVIEW_HIDE(id _view);
void OBJB_NSVIEW_VISIBLE(id _view, id Value);
id   OBJB_NSVIEW_VISIBLE(id _view);
void OBJB_NSVIEW_TOOLTIP(id _view, id Value);
id   OBJB_NSVIEW_TOOLTIP(id _view);
void OBJB_NSVIEW_TAG(id _view, id Value);
id   OBJB_NSVIEW_TAG(id _view);
void OBJB_NSVIEW_X(id _view, id Value);
id   OBJB_NSVIEW_X(id _view);
void OBJB_NSVIEW_Y(id _view, id Value);
id   OBJB_NSVIEW_Y(id _view);
void OBJB_NSVIEW_WIDTH(id _view, id Value);
id   OBJB_NSVIEW_WIDTH(id _view);
void OBJB_NSVIEW_HEIGHT(id _view, id Value);
id   OBJB_NSVIEW_HEIGHT(id _view);
void OBJB_NSVIEW_FRAME(id _view, id Value);
id   OBJB_NSVIEW_FRAME(id _view);
void OBJB_NSVIEW_BOUNDS(id _view, id Value);
id   OBJB_NSVIEW_BOUNDS(id _view);
void OBJB_NSVIEW_WINDOW(id _view, id Value);
id   OBJB_NSVIEW_WINDOW(id _view);

id   OBJB_NSPATHCONTROL_INIT(id object, const char *Name_OnAction);
id   OBJB_NSCOLORWELL_INIT(id object, const char *Name_OnAction);

id OBJB_NSIMAGEVIEW_INIT(id object, const char *Name_OnAction, id Value);
id   OBJB_NSIMAGEVIEW_INIT(id object, const char *Name_OnAction);
void OBJB_NSIMAGEVIEW_IMAGESCALING(id imagewell, id Value);
id   OBJB_NSIMAGEVIEW_IMAGESCALING(id imagewell);
void OBJB_NSIMAGEVIEW_IMAGE(id imagewell, id Value);
id   OBJB_NSIMAGEVIEW_IMAGE(id imagewell);

id   OBJB_NSLEVELINDICATOR_INIT(id object, const char *Name_OnAction);
id OBJB_INDETERMINATEPROGRESSINDICATOR_INIT(id object, const char *Name_OnAction);
id OBJB_CIRCULARPROGRESSINDICATOR_INIT(id object, const char *Name_OnAction);
id   OBJB_NSPROGRESSINDICATOR_INIT(id object, const char *Name_OnAction);
void OBJB_NSPROGRESSINDICATOR_STARTANIMATION(id progressindicator, id Value);
void OBJB_NSPROGRESSINDICATOR_DOUBLEVALUE(id progressindicator, id Value);
id   OBJB_NSPROGRESSINDICATOR_DOUBLEVALUE(id progressindicator);
void OBJB_NSPROGRESSINDICATOR_MINVALUE(id progressindicator, id Value);
id   OBJB_NSPROGRESSINDICATOR_MINVALUE(id progressindicator);
void OBJB_NSPROGRESSINDICATOR_MAXVALUE(id progressindicator, id Value);
id   OBJB_NSPROGRESSINDICATOR_MAXVALUE(id progressindicator);

id   OBJB_NSTEXTVIEW_INIT(id object, const char *Name_OnAction);
id OBJB_OBTEXTVIEW_INIT(id object, const char *Name_OnAction);
void OBJB_NSTEXTVIEW_DELEGATE(id textview, id Value);
id   OBJB_NSTEXTVIEW_DELEGATE(id textview);
void OBJB_NSTEXTVIEW_APPEND(id textview, id Value);

void OBJB_OBTEXTVIEW_PRINTSHOWINGPRINTPANEL(id textview, id sProjectName, id sProjectFile, id Flag);
void OBJB_OBTEXTVIEW_TOGGLEBREAKPOINT(id textview);
void OBJB_OBTEXTVIEW_TURNOFFWRAPPING(id textview);
void OBJB_OBTEXTVIEW_TURNONAUTOINDENT(id textview);
void OBJB_OBTEXTVIEW_PERFORMSYNTAXHIGHLIGHTING(id textview);
void OBJB_OBTEXTVIEW_LOWERCASE(id textview);
void OBJB_OBTEXTVIEW_UPPERCASE(id textview);
void OBJB_OBTEXTVIEW_AUTOFORMAT(id textview);
void OBJB_OBTEXTVIEW_SHIFTLEFT(id textview);
void OBJB_OBTEXTVIEW_SHIFTRIGHT(id textview);
void OBJB_OBTEXTVIEW_COMMENT(id textview);
void OBJB_OBTEXTVIEW_UNCOMMENT(id textview);
id   OBJB_NSTEXTVIEW_SELECTEDTEXT(id textview);
void OBJB_OBTEXTVIEW_FILENAME(id textview, id Value);
id   OBJB_OBTEXTVIEW_FILENAME(id textview);
id OBJB_OBTEXTVIEW_LOAD(id textview, id Value);
id OBJB_OBTEXTVIEW_SAVE(id textview, id Value);
id OBJB_OBTEXTVIEW_FINDNEXT(id textview, id Value);
id OBJB_OBTEXTVIEW_FINDPREVIOUS(id textview, id Value);
id OBJB_OBTEXTVIEW_FINDREPLACE(id textview, id Value);
id OBJB_OBTEXTVIEW_FINDREPLACEFIND(id textview, id Find, id Replace);
id OBJB_OBTEXTVIEW_FINDREPLACEALL(id textview, id Find, id Replace);
void OBJB_OBTEXTVIEW_FINDSETOPTIONIGNORECASE(id textview, id Value);
void OBJB_OBTEXTVIEW_FINDSETOPTIONSELECTEDTEXTONLY(id textview, id Value);
void OBJB_OBTEXTVIEW_FINDSETOPTIONWHOLEWORDSONLY(id textview, id Value);
void OBJB_OBTEXTVIEW_GOTOLINE(id textview, id Value);
void OBJB_NSTEXTVIEW_GOTOFIRSTCHARACTER(id textview);
id OBJB_OBTEXTVIEW_LINE(id textview);
id OBJB_OBTEXTVIEW_POSITION(id textview);
void OBJB_NSTEXTVIEW_PERFORMFINDPANELACTION(id textview, id Value);
void OBJB_NSTEXTVIEW_INSERT(id textview, id Value);
void OBJB_NSTEXTVIEW_CUT(id textview);
void OBJB_NSTEXTVIEW_COPY(id textview);
void OBJB_NSTEXTVIEW_PASTE(id textview);
void OBJB_NSTEXTVIEW_DELETE(id textview);
void OBJB_NSTEXTVIEW_UNDO(id textview);
void OBJB_NSTEXTVIEW_REDO(id textview);
id   OBJB_NSTEXTVIEW_CANUNDO(id textview);
id   OBJB_NSTEXTVIEW_CANREDO(id textview);
void OBJB_OBTEXTVIEW_LINESEPARATORS(id textview, id Value);
id OBJB_OBTEXTVIEW_LINESEPARATORS(id textview);
void OBJB_OBTEXTVIEW_BREAKPOINTS(id textview, id Value);
id OBJB_OBTEXTVIEW_BREAKPOINTS(id textview);
void OBJB_OBTEXTVIEW_KEYWORDS(id textview, id Value);
id OBJB_OBTEXTVIEW_KEYWORDS(id textview);
void OBJB_OBTEXTVIEW_COMMANDS(id textview, id Value);
id OBJB_OBTEXTVIEW_COMMANDS(id textview);
void OBJB_OBTEXTVIEW_TYPES(id textview, id Value);
id OBJB_OBTEXTVIEW_TYPES(id textview);
void OBJB_NSTEXTVIEW_FONT(id textview, id Value);
id   OBJB_NSTEXTVIEW_FONT(id textview);
id   OBJB_NSTEXTVIEW_HASSELECTION(id textview);
void OBJB_NSTEXTVIEW_VALUE(id textview, id Value);
id   OBJB_NSTEXTVIEW_VALUE(id textview);
void OBJB_NSTEXTVIEW_RICHTEXT(id textview, id Value);
id   OBJB_NSTEXTVIEW_RICHTEXT(id textview);
void OBJB_NSTEXTVIEW_ALLOWSUNDO(id textview, id Value);
id   OBJB_NSTEXTVIEW_ALLOWSUNDO(id textview);

id   OBJB_NSSEGMENTEDCONTROL_INIT(id object, const char *Name_OnAction);
id   OBJB_NSSEGMENTEDCONTROL_SELECTED(id   OBJB_NSsegmentedcontrol);
id OBJB_CIRCULARSLIDER_INIT(id object, const char *Name_OnAction);
id   OBJB_NSSLIDER_INIT(id object, const char *Name_OnAction);
void OBJB_NSCELL_EDITABLE(id cell, id Value);
id   OBJB_NSCELL_EDITABLE(id cell);
void OBJB_NSCELL_ENABLED(id cell, id Value);
id   OBJB_NSCELL_ENABLED(id cell);
void OBJB_NSCELL_FONT(id cell, id Value);
id   OBJB_NSCELL_FONT(id cell);
void OBJB_NSCELL_OBJECTVALUE(id cell, id Value);
id   OBJB_NSCELL_OBJECTVALUE(id cell);
void OBJB_NSCELL_STRINGVALUE(id cell, id Value);
id   OBJB_NSCELL_STRINGVALUE(id cell);

id OBJB_NSFONT_INIT(id object, const char *Name_OnAction, id Name, id Size);
void OBJB_NSFONT_FONT(id text, id Value);
id   OBJB_NSFONT_FONT(id text);

id   OBJB_NSPOPUPBUTTON_INIT(id object, const char *Name_OnAction);
void OBJB_NSPOPUPBUTTON_PULLSDOWN(id popupbutton, id Value);
id   OBJB_NSPOPUPBUTTON_PULLSDOWN(id popupbutton);
void OBJB_NSPOPUPBUTTON_AUTOENABLESITEMS(id popupbutton, id Value);
id   OBJB_NSPOPUPBUTTON_AUTOENABLESITEMS(id popupbutton);
void OBJB_NSPOPUPBUTTON_MENU(id popupbutton, id Value);
id   OBJB_NSPOPUPBUTTON_MENU(id popupbutton);
void OBJB_NSPOPUPBUTTON_APPEND(id popupbutton, id Value);
void OBJB_NSPOPUPBUTTON_APPENDWITHIMAGE(id popupbutton, id Image, id Value);
void OBJB_NSPOPUPBUTTON_INSERT(id popupbutton, id Index, id Value);
void OBJB_NSPOPUPBUTTON_INSERTWITHIMAGE(id popupbutton, id Index, id Image, id Value);
void OBJB_NSPOPUPBUTTON_REMOVE(id popupbutton, id Value);
void OBJB_NSPOPUPBUTTON_REMOVETITLE(id popupbutton, id Value);
void OBJB_NSPOPUPBUTTON_REMOVEALL(id popupbutton);
id   OBJB_NSPOPUPBUTTON_SELECTED(id popupbutton);
id   OBJB_NSPOPUPBUTTON_SELECTEDTITLE(id popupbutton);
id   OBJB_NSPOPUPBUTTON_SELECTEDOBJECT(id popupbutton);
id   OBJB_NSPOPUPBUTTON_COUNT(id popupbutton);
id   OBJB_NSPOPUPBUTTON_OBJECT(id popupbutton, id Value);
id   OBJB_NSPOPUPBUTTON_INDEX(id popupbutton, id Value);
void OBJB_NSPOPUPBUTTON_SELECT(id popupbutton, id Value);
void OBJB_NSPOPUPBUTTON_SELECTTITLE(id popupbutton, id Value);
void OBJB_NSPOPUPBUTTON_UNSELECTALL(id popupbutton);
void OBJB_NSPOPUPBUTTON_SYNCHRONIZE(id popupbutton);

id   OBJB_NSCOMBOBOX_INIT(id object, const char *Name_OnAction);
void OBJB_NSCOMBOBOX_COMPLETES(id combobobox, id Value);
id   OBJB_NSCOMBOBOX_COMPLETES(id combobobox);
void OBJB_NSCOMBOBOX_VERTICALSCROLLER(id combobobox, id Value);
id   OBJB_NSCOMBOBOX_VERTICALSCROLLER(id combobobox);
void OBJB_NSCOMBOBOX_BUTTONBORDERED(id combobobox, id Value);
id   OBJB_NSCOMBOBOX_BUTTONBORDERED(id combobobox);
void OBJB_NSCOMBOBOX_ITEMHEIGHT(id combobobox, id Value);
id   OBJB_NSCOMBOBOX_ITEMHEIGHT(id combobobox);
void OBJB_NSCOMBOBOX_INTERCELLSPACING(id combobobox, id Value);
id   OBJB_NSCOMBOBOX_INTERCELLSPACING(id combobobox);
void OBJB_NSCOMBOBOX_SETNUMBEROFVISIBLEITEMS(id combobobox, id Value);
id   OBJB_NSCOMBOBOX_COUNT(id combobobox);
void  OBJB_NSCOMBOBOX_APPEND(id combobobox, id Value);
void OBJB_NSCOMBOBOX_APPENDSEPARATOR(id combobobox);
void OBJB_NSCOMBOBOX_INSERT(id combobobox, id Index, id Value);
void OBJB_NSCOMBOBOX_REMOVEALL(id combobobox);
void OBJB_NSCOMBOBOX_REMOVE(id combobobox, id Value);
void OBJB_NSCOMBOBOX_REMOVEOBJECT(id combobobox, id Value);
id   OBJB_NSCOMBOBOX_INDEX(id combobobox, id Value);
id   OBJB_NSCOMBOBOX_CONTAINS(id combobobox, id Value);
id   OBJB_NSCOMBOBOX_OBJECT(id combobobox, id Value);
void OBJB_NSCOMBOBOX_SCROLLTO(id combobobox, id Value);
void OBJB_NSCOMBOBOX_UNSELECT(id combobobox, id Value);
id   OBJB_NSCOMBOBOX_SELECTED(id combobobox);
id   OBJB_NSCOMBOBOX_SELECTEDOBJECT(id combobobox);
void OBJB_NSCOMBOBOX_SELECT(id combobobox, id Value);
void OBJB_NSCOMBOBOX_SELECTOBJECT(id combobobox, id Value);

id   OBJB_NSSTEPPER_INIT(id object, const char *Name_OnAction);
id   OBJB_NSDATEPICKER_INIT(id object, const char *Name_OnAction);
id   OBJB_NSTOKENFIELD_INIT(id object, const char *Name_OnAction);

id   OBJB_NSSEARCHFIELD_INIT(id object, const char *Name_OnAction);
void OBJB_NSSEARCHFIELD_RECENTSEARCHES(id   OBJB_NSsearchfield, id Value);
id   OBJB_NSSEARCHFIELD_RECENTSEARCHES(id   OBJB_NSsearchfield);
void OBJB_NSSEARCHFIELD_RECENTSAUTOSAVENAME(id   OBJB_NSsearchfield, id Value);
id   OBJB_NSSEARCHFIELD_RECENTSAUTOSAVENAME(id   OBJB_NSsearchfield);
void OBJB_NSSEARCHFIELD_SENDSWHOLESEARCHSTRING(id   OBJB_NSsearchfield, id Value);
id   OBJB_NSSEARCHFIELD_SENDSWHOLESEARCHSTRING(id   OBJB_NSsearchfield);

id   OBJB_NSSECURETEXTFIELD_INIT(id object, const char *Name_OnAction);
id OBJB_LABEL_INIT(id object, const char *Name_OnAction);

id   OBJB_NSTEXTFIELD_INIT(id object, const char *Name_OnAction);
void OBJB_NSTEXTFIELD_BEZELSTYLE(id textfield, id Value);
id   OBJB_NSTEXTFIELD_BEZELSTYLE(id textfield);
void OBJB_NSTEXTFIELD_DELEGATE(id textfield, id Value);
id   OBJB_NSTEXTFIELD_DELEGATE(id textfield);
void OBJB_NSTEXTFIELD_ALLOWSEDITINGTEXTATTRIBUTES(id textfield, id Value);
id   OBJB_NSTEXTFIELD_ALLOWSEDITINGTEXTATTRIBUTES(id textfield);
void OBJB_NSTEXTFIELD_EDITABLE(id textfield, id Value);
id   OBJB_NSTEXTFIELD_EDITABLE(id textfield);
void OBJB_NSTEXTFIELD_SELECTABLE(id textfield, id Value);
id   OBJB_NSTEXTFIELD_SELECTABLE(id textfield);
void OBJB_NSTEXTFIELD_TEXTCOLOR(id textfield, id Value);
id   OBJB_NSTEXTFIELD_TEXTCOLOR(id textfield);
void OBJB_NSTEXTFIELD_SELECTTEXT(id textfield);
void OBJB_NSTEXTFIELD_BACKGROUNDCOLOR(id textfield, id Value);
id   OBJB_NSTEXTFIELD_BACKGROUNDCOLOR(id textfield);
void OBJB_NSTEXTFIELD_DRAWSBACKGROUND(id textfield, id Value);
id   OBJB_NSTEXTFIELD_DRAWSBACKGROUND(id textfield);
void OBJB_NSTEXTFIELD_BEZELED(id textfield, id Value);
id   OBJB_NSTEXTFIELD_BEZELED(id textfield);
void OBJB_NSTEXTFIELD_BORDERED(id textfield, id Value);
id   OBJB_NSTEXTFIELD_BORDERED(id textfield);

void OBJB_STDOUT(id data);
void OBJB_STDERR(id data);
id   OBJB_NSTASK_INIT(id object, const char *Name_OnAction);

id OBJB_OBTASK_INIT(id object, const char *Name_OnAction);
void OBJB_OBTASK_PATH(id task, id Value);
id OBJB_OBTASK_PATH(id task);
void OBJB_OBTASK_ARGUMENTS(id task, id Value);
id OBJB_OBTASK_ARGUMENTS(id task);
void OBJB_OBTASK_PID(id task, id Value);
id OBJB_OBTASK_PID(id task);
void OBJB_OBTASK_CURRENTDIRECTORY(id task, id Value);
id OBJB_OBTASK_CURRENTDIRECTORY(id task);
void OBJB_OBTASK_ENVIRONMENT(id task, id Value);
id OBJB_OBTASK_ENVIRONMENT(id task);
id OBJB_OBTASK_RESUME(id task);
id OBJB_OBTASK_SUSPEND(id task);
id OBJB_OBTASK_ISRUNNING(id task);
id OBJB_OBTASK_EXITSTATUS(id task);
void OBJB_OBTASK_LAUNCHANDWAIT(id task);
void OBJB_OBTASK_STARTANDWAIT(id task, id SetFrontProcess);
void OBJB_OBTASK_STOP(id task);
void OBJB_OBTASK_STDIN(id task, id data);

id OBJB_NSIMAGE_INIT(id object, const char *Name_OnAction, id m);
id OBJB_NSIMAGE_INIT(id object, const char *Name_OnAction);


id OBJB_NSTIMER_INIT(id object, const char *Name_OnAction, id Interval);
id   OBJB_NSTIMER_INIT(id object, const char *Name_OnAction);
void OBJB_NSTIMER_STOP(id timer);

id OBJB_NSCOLOR_INIT(id object, const char *Name_OnAction, id Red, id Green, id Blue, id Alpha);

id   OBJB_NSTHREAD_INIT(id object, const char *Name_OnAction);
void OBJB_NSTHREAD_START(id thread);
void OBJB_NSTHREAD_CANCEL(id thread);
id   OBJB_NSTHREAD_ISEXECUTING(id thread);
id   OBJB_NSTHREAD_ISFINISHED(id thread);
id   OBJB_NSTHREAD_ISCANCELLED(id thread);

id OBJB_RADIOBUTTON_INIT(id object, const char *Name_OnAction);
id OBJB_CHECKBOX_INIT(id object, const char *Name_OnAction);
id OBJB_ROUNDBUTTON_INIT(id object, const char *Name_OnAction);
id OBJB_DISCLOSUREBUTTON_INIT(id object, const char *Name_OnAction);
id OBJB_RECESSEDBUTTON_INIT(id object, const char *Name_OnAction);
id OBJB_ROUNDEDRECTBUTTON_INIT(id object, const char *Name_OnAction);
id OBJB_ROUNDEDTEXTUREDBUTTON_INIT(id object, const char *Name_OnAction);
id OBJB_GRADIENTBUTTON_INIT(id object, const char *Name_OnAction);
id OBJB_HELPBUTTON_INIT(id object, const char *Name_OnAction);
id OBJB_TEXTUREDBUTTON_INIT(id object, const char *Name_OnAction);
id OBJB_SQUAREBUTTON_INIT(id object, const char *Name_OnAction);
id OBJB_DISCLOSURETRIANGLE_INIT(id object, const char *Name_OnAction);
id OBJB_BEVELBUTTON_INIT(id object, const char *Name_OnAction);
id OBJB_PUSHBUTTON_INIT(id object, const char *Name_OnAction);
id   OBJB_NSBUTTON_INIT(id object, const char *Name_OnAction);
void OBJB_NSBUTTON_FRAME(id button, id Value);
void OBJB_NSBUTTON_BEZELSTYLE(id button, id Value);
id   OBJB_NSBUTTON_BEZELSTYLE(id button);
void OBJB_NSBUTTON_BUTTONTYPE(id button, id Value);
id   OBJB_NSBUTTON_BUTTONTYPE(id button);
void OBJB_NSBUTTON_TITLE(id button, id Value);
id   OBJB_NSBUTTON_TITLE(id button);
void OBJB_NSBUTTON_ALTERNATETITLE(id button, id Value);
id   OBJB_NSBUTTON_ALTERNATETITLE(id button);
void OBJB_NSBUTTON_ATTRIBUTEDTITLE(id button, id Value);
id   OBJB_NSBUTTON_ATTRIBUTEDTITLE(id button);
void OBJB_NSBUTTON_ATTRIBUTEDALTERNATETITLE(id button, id Value);
id   OBJB_NSBUTTON_ATTRIBUTEDALTERNATETITLE(id button);
void OBJB_NSBUTTON_KEYEQUIVLANET(id button, id Value);
id   OBJB_NSBUTTON_KEYEQUIVLANET(id button);
void OBJB_NSBUTTON_KEYEQUIVLANETMODIFIERMASK(id button, id Value);
id   OBJB_NSBUTTON_KEYEQUIVLANETMODIFIERMASK(id button);
id   OBJB_NSBUTTON_SOUND(id button);
void OBJB_NSBUTTON_SETNEXTSTATE(id button);
void OBJB_NSBUTTON_HIGHLIGHT(id button, id Value);
void OBJB_NSBUTTON_TRANSPARENT(id button, id Value);
id   OBJB_NSBUTTON_TRANSPARENT(id button);
void OBJB_NSBUTTON_BORDERED(id button, id Value);
id   OBJB_NSBUTTON_BORDERED(id button);
void OBJB_NSBUTTON_ALLOWSMIXEDSTATE(id button, id Value);
id   OBJB_NSBUTTON_ALLOWSMIXEDSTATE(id button);
void OBJB_NSBUTTON_IMAGEPOSITION(id button, id Value);
id   OBJB_NSBUTTON_IMAGEPOSITION(id button);
void OBJB_NSBUTTON_IMAGE(id button, id Value);
id   OBJB_NSBUTTON_IMAGE(id button);
void OBJB_NSBUTTON_ALTERNATEIMAGE(id button, id Value);
id   OBJB_NSBUTTON_ALTERNATEIMAGE(id button);
void OBJB_NSBUTTON_STATE(id button, id Value);
id   OBJB_NSBUTTON_STATE(id button);

id OBJB_READSTRING(id m);
id OBJB_WRITESTRING(id m, id n);
id OBJB_LEN(id m);
id OBJB_AT(id m, id n);
id OBJB_UNICODE(id m, id n);
id OBJB_FILENAME(id m);
id OBJB_FILEEXTENSION(id m);
id OBJB_FILEPATH(id m);
id OBJB_SPACE(id m, id n);
id OBJB_LEFT(id m, id n);
id OBJB_MID(id m, id n, id k);
id OBJB_RIGHT(id m, id n);
id OBJB_SPLIT(id m, id n);
id OBJB_JOIN(id m, id n);
id OBJB_TRIM(id m);
id OBJB_INSTR(id m, id n, id k, id b);
id OBJB_INSTRREV(id m, id n, id k, id b);
id OBJB_CONTAINS(id m, id n, id b);
id OBJB_FORMAT(id m, id b);
id OBJB_HEX(id m);
id OBJB_CHARACTER(id m);
id OBJB_FORMATFLOAT(id m, id b, id l);
id OBJB_FORMATDECIMAL(id m, id b, id l);
id OBJB_APPEND(id m, id n);
id OBJB_PREPEND(id m, id n);
id OBJB_LCASE(id m);
id OBJB_UCASE(id m);
id OBJB_COMPARE(id m, id n, id b);
id OBJB_REPLACE(id m, id n, id k, id b);
id OBJB_COUNT(id m, id n, id b);
id OBJB_STARTSWITH(id m, id n, id b);
id OBJB_ENDSWITH(id m, id n, id b);
void OBJB_BEEP();

id OBJB_RANGE_INIT(id object, const char *Name_OnAction, id Location, id Length);
id OBJB_POINT_INIT(id object, const char *Name_OnAction, id X, id Y);
id OBJB_SIZE_INIT(id object, const char *Name_OnAction, id Width, id Height);
id OBJB_RECT_INIT(id object, const char *Name_OnAction, id X, id Y, id Width, id Height);

id OBJB_OFFSETRECT(id otherRect, id OffsetX, id OffsetY);
id OBJB_INTERSECTIONRECT(id rect1, id rect2);
id OBJB_UNIONRECT(id rect1, id rect2);
id OBJB_INSETRECT(id otherRect, id OffsetX, id OffsetY);
id OBJB_POINTINRECT(id p, id rect2);
id OBJB_CONTAINSRECT(id rect1, id rect2);
id OBJB_INTERSECTSRECT(id rect1, id rect2);
id OBJB_ISEMPTYRECT(id rect1);

void OBJB_EXCEPTION(id m, id n, id k);
void OBJB_BEGINEXPANDING(id theView, id theWindow);
void OBJB_ENDEXPANDING(id theView, id theWindow);
void OBJB_BEGINALERTSHEET(id _self, id m, id n, id z, id a, id b, id c);
void OBJB_BEGINSHEET(id _self, id m, id z);
void OBJB_ENDSHEET(id m, id ReturnCode);
id OBJB_BEGINMODAL(id m);
void OBJB_ENDMODAL(id ReturnCode);
void OBJB_BEGINDRAWER(id m);
void OBJB_ENDDRAWER(id m);
id OBJB_ALERTPANEL(id m, id n, id a, id b, id c);
id OBJB_CRITICALALERTPANEL(id m, id n, id a, id b, id c);
id OBJB_INFORMATIONALALERTPANEL(id m, id n, id a, id b, id c);
id OBJB_MSGBOX(id m, id n);
id OBJB__MSGBOX(id n);
id OBJB_SCREENRECT();
id OBJB_INPUTPANEL(id m, id n, id k);
void OBJB_PREVIEW(id m);
//void OBJB_PREFERENCES();
void OBJB_TEXTEDIT(id m);
void OBJB_SAFARI(id m);
void OBJB_FINDER(id m);
void OBJB_OBJBINTERFACEBUILDER(id m);
id OBJB_LAUNCH(id m, id a, id b);
id OBJB_CLASSNAME(id m);
id OBJB_TYPENAME(id m);
id OBJB_CLONE(id m);
id OBJB_INFO(id m);
id OBJB_RUN(id m);
id OBJB_OBJBRUNOBJBCOMPILE(id a2);
id OBJB_OBJBRUNOBJCHEADER(id a2);
id OBJB_OBJBRUNOBJCCOMPILE(id a2);
id OBJB_OBJBRUNOBJCLINKER(id a2);
id OBJB_OBJBRUNTIMEPATH();
id OBJB_OBJBBINARYPATH();
id OBJB_OBJBEXAMPLESPATH();
id OBJB_BASH(id m, id a2);
id OBJB_RUN(id m, id a2);
void OBJB_DORUNLOOP(id m);
id OBJB_ARCH();
id OBJB_IS32BIT();
id OBJB_IS64BIT();
id OBJB_ISEQUALCLASS(id l, id r);
id OBJB_ISEQUALVALUE(id l, id r);
id OBJB_ISEQUALOBJECT(id l, id r);
id OBJB_ISARRAY(id l);
id OBJB_ISDICTIONARY(id l);
id OBJB_ISSTRING(id l);
id OBJB_ISBOOLEAN(id l);
id OBJB_ISBYTE(id l);
id OBJB_ISDATA(id l);
id OBJB_ISDOUBLE(id l);
id OBJB_ISINTEGER(id l);
id OBJB_ISNUMBER(id l);
id OBJB_ISVALUE(id l);
id OBJB_ISSHORT(id l);
id OBJB_ISLONG(id l);
id OBJB_ISPOINT(id l);
id OBJB_ISRANGE(id l);
id OBJB_ISRECT(id l);
id OBJB_ISSINGLE(id l);
id OBJB_ISSIZE(id l);
void OBJB_RANDOMIZE();
id OBJB_RANDOM(BOOL bExpression, id dValue);
//id OBJB_RANDOM();
id OBJB_RANDOM(id dValue);

id OBJB_BITCLR(id Value, id Position);
id OBJB_BITSET(id Value, id Position);
id OBJB_BITTST(id Value, id Position);

id OBJB_ABS(id l);
id OBJB_ATN(id l);
id OBJB_COS(id l);
id OBJB_SIN(id l);
id OBJB_EXP(id l);
id OBJB_LN(id l);
id OBJB_LOG10(id l);
id OBJB_FIX(id l);
id OBJB_INT(id l);
id OBJB_SQR(id l);
id OBJB_TAN(id l);


id OBJB_MIN(id l, id r);
id OBJB_MAX(id l, id r);
id OBJB_FACT(id m);
id OBJB_ROUND(id l, id r);
id OBJB_MODF_FRACTIONAL(id m);
id OBJB_MODF_INTEGRAL(id m);
/*
id OBJB_FREXP_NORMALIZED(id m);
id OBJB_FREXP_INTEGRAL(id m);
 */



id OBJB_PROPERTY(id a, id b);
void OBJB_PROPERTY(id a, id b, id c);

id OBJB_READKEYEDARCHIVE(id m);
id OBJB_WRITEKEYEDARCHIVE(id m, id n);
id OBJB_READARRAY(id m);
id OBJB_READDICTIONARY(id m);
id OBJB_PLIST(id m);
id OBJB_READDATA(id m);
id OBJB_WRITEARRAY(id m, id n);
id OBJB_WRITEDICTIONARY(id m, id n);
id OBJB_WRITEDATA(id m, id n);

//NSSound *SOUND(id m);

//NSImage *IMAGE(id m);

// global variables

/*
 extern id idAPPLICATION;
 extern id id_FILE;
 extern id idFIRSTRESPONDER;
 extern id GLOBAL;
 */
NSImage *OBJB_CNSIMAGE(id m);

OBTask *OBJB_COBTASK(id m);

//OBMenuItem *OBMENUITEM(id m);

OBTextView *OBJB_COBTEXTVIEW(id m);

NSResponder *OBJB_CNSRESPONDER(id m);

NSMenuItem *OBJB_CNSMENUITEM(id m);

//NSMenu *MENU(id m);

NSMutableString *OBJB_CSTRING(id m);

NSAttributedString *OBJB_CATTRIBUTEDSTRING(id m);

NSData *OBJB_CDATA(id m);

BOOL OBJB_CBOOL(BOOL m); // needed for condition

BOOL OBJB_CBOOL(id m);

NSInteger OBJB_CBYTE(id m);

NSInteger OBJB_CSHORT(id m);

NSInteger OBJB_CINTEGER(id m);

NSInteger OBJB_CNSINTEGER(id m);

long long OBJB_CLONG(id m);

float OBJB_CSINGLE(id m);

double OBJB_CDOUBLE(id m);


NSPoint OBJB_CNSPOINT(id m);

void OBJB_POINT_X(id *m, id Value);

id OBJB_POINT_X(id m);

id OBJB_POINT_X(NSPoint m);

void OBJB_POINT_Y(id *m, id Value);

id OBJB_POINT_Y(id m);

id OBJB_POINT_Y(NSPoint m);



NSSize OBJB_CNSSIZE(id m);

void OBJB_SIZE_WIDTH(id *m, id Value);

id OBJB_SIZE_WIDTH(id m);

id OBJB_SIZE_WIDTH(NSSize m);

void OBJB_SIZE_HEIGHT(id *m, id Value);

id OBJB_SIZE_HEIGHT(id m);

id OBJB_SIZE_HEIGHT(NSSize m);



NSRange OBJB_CNSRANGE(id m);

void OBJB_RANGE_LOCATION(id *m, id Value);

id OBJB_RANGE_LOCATION(id m);

id OBJB_RANGE_LOCATION(NSRange m);

void OBJB_RANGE_LENGTH(id *m, id Value);

id OBJB_RANGE_LENGTH(id m);

id OBJB_RANGE_LENGTH(NSRange m);


NSRect OBJB_CNSRECT(id m);

id OBJB_RECT_SIZE(id m);

id OBJB_RECT_SIZE(NSRect m);

void OBJB_RECT_ORIGIN(id *m, id Value);

id OBJB_RECT_ORIGIN(id m);

id OBJB_RECT_ORIGIN(NSRect m);

void OBJB_RECT_SIZE(id *m, id Value);

NSWindow *OBJB_CNSWINDOW(id m);
NSPanel *OBJB_CNSPANEL(id m);
NSTask *OBJB_CNSTASK(id m);
OBBackgroundView *OBJB_COBBACKGROUNDVIEW(id m);
OBPreferences *OBJB_COBPREFERENCES(id m);
NSButton *OBJB_CNSBUTTON(id m);
NSButton *OBJB_CPUSHBUTTON(id m);
NSButton *OBJB_CGRADIENTBUTTON(id m);
NSButton *OBJB_CROUNDBUTTON(id m);
NSButton *OBJB_CDISCLOSUREBUTTON(id m);
NSButton *OBJB_CRECESSEDBUTTON(id m);
NSButton *OBJB_CROUNDEDRECTBUTTON(id m);
NSButton *OBJB_CROUNDEDTEXTUREDBUTTON(id m);
NSButton *OBJB_CHELPBUTTON(id m);
NSButton *OBJB_CTEXTUREDBUTTON(id m);
NSButton *OBJB_CSQUAREBUTTON(id m);
NSButton *OBJB_CDISCLOSURETRIANGLE(id m);
NSButton *OBJB_CBEVELBUTTON(id m);
NSButton *OBJB_CCHECKBOX(id m);
NSButton *OBJB_CRADIOBUTTON(id m);
NSMatrix *OBJB_CNSMATRIX(id m);
NSPopUpButtonCell *OBJB_CNSPOPUPBUTTONCELL(id m);
NSImageCell *OBJB_CNSIMAGECELL(id m);
NSTimer *OBJB_CNSTIMER(id m);
NSThread *OBJB_CNSTHREAD(id m);
NSDrawer *OBJB_CNSDRAWER(id m);
NSCell *OBJB_CNSCELL(id m);
NSActionCell *OBJB_CNSACTIONCELL(id m);
NSButtonCell *OBJB_CNSBUTTONCELL(id m);
NSTextField *OBJB_CNSTEXTFIELD(id m);
NSTextField *OBJB_CLABEL(id m);
NSSecureTextField *OBJB_CNSSECURETEXTFIELD(id m);
NSSearchField *OBJB_CNSSEARCHFIELD(id m);
NSTokenField *OBJB_CNSTOKENFIELD(id m);
NSDatePicker *OBJB_CNSDATEPICKER(id m);
NSStepper *OBJB_CNSSTEPPER(id m);
NSComboBox *OBJB_CNSCOMBOBOX(id m);
NSPopUpButton *OBJB_CNSPOPUPBUTTON(id m);
NSSlider *OBJB_CNSSLIDER(id m);
NSSlider *OBJB_CCIRCULARSLIDER(id m);
NSSegmentedControl *OBJB_CNSSEGMENTEDCONTROL(id m);
NSTextView *OBJB_CNSTEXTVIEW(id m);
NSProgressIndicator *OBJB_CNSPROGRESSINDICATOR(id m);
NSProgressIndicator *OBJB_CCIRCULARPROGRESSINDICATOR(id m);
NSProgressIndicator *OBJB_CINDETERMINATEPROGRESSINDICATOR(id m);
NSLevelIndicator *OBJB_CNSLEVELINDICATOR(id m);
NSImageView *OBJB_CNSIMAGEVIEW(id m);
NSColorWell *OBJB_CNSCOLORWELL(id m);
NSPathControl *OBJB_CNSPATHCONTROL(id m);
NSView *OBJB_CNSVIEW(id m);
NSSplitView *OBJB_CNSSPLITVIEW(id m);
NSSplitView *OBJB_CVERTICALSPLITVIEW(id m);
NSSplitView *OBJB_CHORIZONTALSPLITVIEW(id m);
NSScrollView *OBJB_CNSSCROLLVIEW(id m);
NSTabView *OBJB_CNSTABVIEW(id m);
NSBox *OBJB_CNSBOX(id m);
NSBox *OBJB_CVERTICALLINE(id m);
NSBox *OBJB_CHORIZONTALLINE(id m);
NSTableView *OBJB_CNSTABLEVIEW(id m);
NSOutlineView *OBJB_CNSOUTLINEVIEW(id m);
NSBrowser *OBJB_CNSBROWSER(id m);
/*NSObject *OBJB_CWEBVIEW(id m);
NSObject *OBJB_CPDFVIEW(id m);
NSObject *OBJB_CMOVIEVIEW(id m);*/
NSFileManager *OBJB_CNSFILEMANAGER(id m);
NSMenu *OBJB_CNSMENU(id m);
NSMenuItem *OBJB_CNSMENUITEM(id m);
NSColor *OBJB_CNSCOLOR(id m);
NSCursor *OBJB_CNSCURSOR(id m);
NSTableColumn *OBJB_CNSTABLECOLUMN(id m);
NSFont *OBJB_CNSFONT(id m);
NSToolbar *OBJB_CNSTOOLBAR(id m);
NSToolbarItem *OBJB_CNSTOOLBARITEM(id m);
NSArray *OBJB_CNSARRAY(id m);
NSMutableArray *OBJB_CNSMUTABLEARRAY(id m);
NSMutableArray *OBJB_CARRAY(id m);
NSDictionary *OBJB_CNSDICTIONARY(id m);
NSMutableDictionary *OBJB_CNSMUTABLEDICTIONARY(id m);
NSMutableDictionary *OBJB_CDICTIONARY(id m);
NSData *OBJB_CNSDATA(id m);
NSMutableData *OBJB_CNSMUTABLEDATA(id m);
NSString *OBJB_CNSSTRING(id m);
NSMutableString *OBJB_CNSMUTABLESTRING(id m);
NSAttributedString *OBJB_CNSATTRIBUTEDSTRING(id m);
NSMutableAttributedString *OBJB_CNSMUTABLEATTRIBUTEDSTRING(id m);


#define objc_bool OBJB_CBOOL
#define objb_bool(a) OBJB_ID((BOOL)a)

#define objc_NSInteger OBJB_CNSINTEGER
#define objb_NSInteger(a) OBJB_ID((NSInteger)a)

#define objc_float OBJB_CDOUBLE
#define objb_float(a) OBJB_ID((double)a)

#define objc_single OBJB_CDOUBLE
#define objb_single(a) OBJB_ID((double)a)

#define objc_double OBJB_CDOUBLE
#define objb_double(a) OBJB_ID((double)a)


#define objc_NSRect OBJB_CNSRECT
#define objb_NSRect(a) OBJB_ID((NSRect)a)

#define objc_NSRange OBJB_CNSRANGE
#define objb_NSRange(a) OBJB_ID((NSRange)a)

#define objc_NSPoint OBJB_CNSPOINT
#define objb_NSPoint(a) OBJB_ID((NSPoint)a)

#define objc_NSSize OBJB_CNSSIZE
#define objb_NSSize(a) OBJB_ID((NSSize)a)




id OBJB__ID(id m);

id OBJB__ID(NSMutableString *m);

id OBJB__ID(BOOL m);

id OBJB__ID(char m);

id OBJB__ID(short m);

//id OBJB__ID(int m);

id OBJB__ID(NSInteger m);

id OBJB__ID(NSUInteger m);

id OBJB__ID(long long m);

id OBJB__ID(float m);

id OBJB__ID(double m);

id OBJB__STRING(id m);

id OBJB__ATTRIBUTEDSTRING(id m);

id OBJB__BOOLEAN(id m);

id OBJB__BYTE(id m);

id OBJB__SHORT(id m);

id OBJB__INTEGER(id m);

id OBJB__LONG(id m);

id OBJB__SINGLE(id m);

id OBJB__DOUBLE(id m);

id OBJB__FLOAT(id m);

id OBJB__DATA(id m);

id OBJB__POINT(id m);

id OBJB__SIZE(id m);

id OBJB__RECT(id m);

id OBJB__RANGE(id m);

id OBJB__NSRESPONDER(id m);

id OBJB__OBTASK(id m);

id OBJB__NSIMAGE(id m);

id OBJB__OBTEXTVIEW(id m);

//id _OBMENUITEM(id m);
id OBJB__NSWINDOW(id m);
id OBJB__NSPANEL(id m);
id OBJB__NSTASK(id m);

id OBJB__OBBACKGROUNDVIEW(id m);
id OBJB__OBPREFERENCES(id m);
 

id OBJB__NSBUTTON(id m);
id OBJB__PUSHBUTTON(id m);
id OBJB__GRADIENTBUTTON(id m);
id OBJB__ROUNDBUTTON(id m);
id OBJB__DISCLOSUREBUTTON(id m);
id OBJB__RECESSEDBUTTON(id m);
id OBJB__ROUNDEDRECTBUTTON(id m);
id OBJB__ROUNDEDTEXTUREDBUTTON(id m);
id OBJB__HELPBUTTON(id m);
id OBJB__TEXTUREDBUTTON(id m);
id OBJB__SQUAREBUTTON(id m);
id OBJB__DISCLOSURETRIANGLE(id m);
id OBJB__BEVELBUTTON(id m);
id OBJB__CHECKBOX(id m);
id OBJB__RADIOBUTTON(id m);
id OBJB__NSMATRIX(id m);
id OBJB__NSPOPUPBUTTONCELL(id m);
id OBJB__NSIMAGECELL(id m);
id OBJB__NSTIMER(id m);
id OBJB__NSTHREAD(id m);
id OBJB__NSDRAWER(id m);
id OBJB__NSCELL(id m);
id OBJB__NSACTIONCELL(id m);
id OBJB__NSBUTTONCELL(id m);
id OBJB__NSTEXTFIELD(id m);
id OBJB__LABEL(id m);
id OBJB__NSSECURETEXTFIELD(id m);
id OBJB__NSSEARCHFIELD(id m);
id OBJB__NSTOKENFIELD(id m);
id OBJB__NSDATEPICKER(id m);
id OBJB__NSSTEPPER(id m);
id OBJB__NSCOMBOBOX(id m);
id OBJB__NSPOPUPBUTTON(id m);
id OBJB__NSSLIDER(id m);
id OBJB__CIRCULARSLIDER(id m);
id OBJB__NSSEGMENTEDCONTROL(id m);
id OBJB__NSTEXTVIEW(id m);
id OBJB__NSPROGRESSINDICATOR(id m);
id OBJB__CIRCULARPROGRESSINDICATOR(id m);
id OBJB__INDETERMINATEPROGRESSINDICATOR(id m);
id OBJB__NSLEVELINDICATOR(id m);
id OBJB__NSIMAGEVIEW(id m);
id OBJB__NSCOLORWELL(id m);
id OBJB__NSPATHCONTROL(id m);
id OBJB__NSVIEW(id m);
id OBJB__NSSPLITVIEW(id m);
id OBJB__VERTICALSPLITVIEW(id m);
id OBJB__HORIZONTALSPLITVIEW(id m);
id OBJB__NSSCROLLVIEW(id m);
id OBJB__NSTABVIEW(id m);
id OBJB__NSBOX(id m);
id OBJB__VERTICALLINE(id m);
id OBJB__HORIZONTALLINE(id m);
id OBJB__NSTABLEVIEW(id m);
id OBJB__NSOUTLINEVIEW(id m);
id OBJB__NSBROWSER(id m);
/*
id OBJB__WEBVIEW(id m);
id OBJB__PDFVIEW(id m);
id OBJB__MOVIEVIEW(id m);
 */
id OBJB__NSFILEMANAGER(id m);
id OBJB__NSMENU(id m);
id OBJB__NSMENUITEM(id m);
id OBJB__NSCOLOR(id m);
id OBJB__NSCURSOR(id m);
id OBJB__NSTABLECOLUMN(id m);
id OBJB__NSFONT(id m);
id OBJB__NSTOOLBAR(id m);
id OBJB__NSTOOLBARITEM(id m);
id OBJB__NSARRAY(id m);
id OBJB__NSMUTABLEARRAY(id m);
id OBJB__ARRAY(id m);
id OBJB__NSDICTIONARY(id m);
id OBJB__NSMUTABLEDICTIONARY(id m);
id OBJB__DICTIONARY(id m);
id OBJB__NSDATA(id m);
id OBJB__NSMUTABLEDATA(id m);
id OBJB__NSSTRING(id m);
id OBJB__NSMUTABLESTRING(id m);
id OBJB__NSATTRIBUTEDSTRING(id m);
id OBJB__NSMUTABLEATTRIBUTEDSTRING(id m);


id OBJB_STRING(id m, id locale);
id OBJB_INTEGER(id m, id locale);
id OBJB_BOOLEAN(id m, id locale);
id OBJB_FLOAT(id m, id locale);
id OBJB_DATA(id m);



