
#import <OBJBRuntime/OBJBRuntime.h>

#import "UKWindow.h"

#import "UKButton.h"

UKWindow *OBJB_sharedUKWindowSingleton = nil;


@implementation UKWindow

- (id) init
{
  if ((self = [super init])){
    [self Init];
  }
  return self;
}

- (id)initWithContentRect:(NSRect)contentRect styleMask:(NSUInteger)windowStyle backing:(NSBackingStoreType)bufferingType defer:(BOOL)deferCreation
{
  if ((self = [super initWithContentRect:contentRect styleMask:windowStyle backing:bufferingType defer:deferCreation])){
    [self Init];
  }
  return self;
}

- (id)initWithContentRect:(NSRect)contentRect styleMask:(NSUInteger)windowStyle backing:(NSBackingStoreType)bufferingType defer:(BOOL)deferCreation screen:(NSScreen *)screen
{
  if ((self = [super initWithContentRect:contentRect styleMask:windowStyle backing:bufferingType defer:deferCreation screen:screen])){
    [self Init];
  }
  return self;
}

- (void) finalize
{
  [super finalize];
}

- (void) awakeFromNib
{
  if (OBJB_sharedUKWindowSingleton == nil) OBJB_sharedUKWindowSingleton = self; //[self Init];
}

- (void) Init
{
                                                                  /*DEBUG*/OBJBS("UKWindow.NSWindow.objb", "Init", "7", "0");
                                                                  /*DEBUG*/OBJBS("UKWindow.NSWindow.objb", "Init", "7", "1");
OBJB_MSGBOX(OBJB_ID(@"UKWindow init"), OBJB_IDNIL());
                                                                  /*DEBUG*/OBJBS("UKWindow.NSWindow.objb", "Init", "8", "2");
}

+ (UKWindow *) sharedUKWindow
{
  @synchronized(self){
    if (OBJB_sharedUKWindowSingleton == nil) OBJB_sharedUKWindowSingleton = [[UKWindow alloc] init];
    return OBJB_sharedUKWindowSingleton;
  }
}

- (IBAction) ukButtonPressed: (id) sender
{
                                                                  /*DEBUG*/OBJBS("UKWindow.NSWindow.objb", "ukButtonPressed", "11", "0");
                                                                  /*DEBUG*/OBJBS("UKWindow.NSWindow.objb", "ukButtonPressed", "11", "1");
OBJB_MSGBOX(OBJB_ID(@"Button Pressed!"), OBJB_IDNIL());
                                                                  /*DEBUG*/OBJBS("UKWindow.NSWindow.objb", "ukButtonPressed", "12", "1");
[myButton setTimer: OBJB_ID((NSInteger) 30)];
                                                                  /*DEBUG*/OBJBS("UKWindow.NSWindow.objb", "ukButtonPressed", "13", "1");
OBJB_MSGBOX(OBJB_CLASSNAME(myButton), OBJB_IDNIL());
                                                                  /*DEBUG*/OBJBS("UKWindow.NSWindow.objb", "ukButtonPressed", "14", "1");
OBJB_MSGBOX(OBJB_CLASSNAME(sender), OBJB_IDNIL());
                                                                  /*DEBUG*/OBJBS("UKWindow.NSWindow.objb", "ukButtonPressed", "15", "2");
}


@end


id OBJB_UKWINDOW_INIT(id object, const char *Name_OnAction)

{
    id aUKWindow = [[UKWindow alloc] init];
    if ([object respondsToSelector:sel_registerName(Name_OnAction)]){
        [aUKWindow setAction:sel_registerName(Name_OnAction)];
        [aUKWindow setTarget:object];
    }
    return aUKWindow;
}

id OBJB__UKWINDOW(id m)

{

    if (m == nil || [m isKindOfClass:[UKWindow class]]){

        return m;

    }

    OBJB_EXCEPTION(OBCastException, @"'UKWindow' expected", [m description]);

    return nil;

}
